using System;
using System.Collections;

namespace TableTree
{
	/// <summary>
	/// Zusammenfassung fr TableTree.
	/// </summary>
	/// 

	public class TableTree
	{
		public ushort runCounter = 8;
		private CellNode [] [,,] nodeBaum;
		public CellLeaf [,,] leafs;
		private int baumtiefe = 0;

		private int []neibCor1 = {-1, 1, 1};

		private int []neibCor2 = {-1, 1, -1};

		private int []neibCor3 = {-1, -1, 1};

		private int []neibCor4 = {-1, -1, -1};

		private int []neibCor5 = {1, 1, 1};

		private int []neibCor6 = {1, 1, -1};

		private int []neibCor7 = {1, -1, 1};

		int []neibCor8 = {1, -1, -1};

		// Nachbarn an den Kanten
		private int []neibBor1 = {-1, 0, -1};

		private int []neibBor2 = {-1, -1, 0};

		private int []neibBor3 = {-1, 0, 1};

		private int []neibBor4 = {-1, 1, 0};

		private int []neibBor5 = {1, -1, 0};

		private int []neibBor6 = {1, 0, 1};

		private int []neibBor7 = {1, 0, -1};

		private int []neibBor8 = {1, 1, 0};

		private int []neibBor9 = {0, 1, 1};

		private int []neibBor10 = {0, 1, -1};

		private int []neibBor11 = {0, -1, 1};

		private int []neibBor12 = {0, -1, -1};

		//Flchen
		private int []neibFace1 = {1, 0, 0};

		private int []neibFace2 = {-1, 0, 0};

		private int []neibFace3 = {0, 1, 0};

		private int []neibFace4 = {0, -1, 0};

		private int []neibFace5 = {0, 0, 1};

		private int []neibFace6 = {0, 0, -1};

		public TableTree (int baumtiefe)
		{
			int borderLenght;
			this.baumtiefe=baumtiefe;
			nodeBaum=new CellNode[baumtiefe][,,];

			for(int level = 0; level<this.baumtiefe; level++)
			{
				borderLenght=(int)System.Math.Pow(2, level);
				nodeBaum[level]=new CellNode[borderLenght, borderLenght, borderLenght];

				//Console.WriteLine(nodeBaum[0][0,0,0].changed[0]);
				//Console.ReadLine();
				for(int i = 0; i<borderLenght; i++)
				{
					for(int j = 0; j<borderLenght; j++)
					{
						for(int k = 0; k<borderLenght; k++)
						{
							nodeBaum[level][i, j, k]=new CellNode();
						}
					}
				}
			}

			borderLenght=(int)System.Math.Pow(2, this.baumtiefe);
			leafs=new CellLeaf[borderLenght, borderLenght, borderLenght];

			for(int i = 0; i<borderLenght; i++)
			{
				for(int j = 0; j<borderLenght; j++)
				{
					for(int k = 0; k<borderLenght; k++)
					{
						leafs[i, j, k]=new CellLeaf();
					}
				}
			}
		}

		public bool CycleStart ()
		{
			int borderLenght;
			bool changed = false;
			Win32.HiPerfTimer timmer = new Win32.HiPerfTimer();
			timmer.Start();

			MoveDown(0, 0, 0, 0, ref changed);
			timmer.Stop();
			Console.WriteLine("zeit: "+timmer.Duration);
			/* for (int level=0; level<baumtiefe; level++)
			 {
				 borderLenght = (int)System.Math.Pow(2,level);
				 for (int i=0; i< borderLenght; i++)
				 {
					 for (int j=0; j< borderLenght; j++)
					 {
						 Console.Write(level+" "+i+" "+j+" ");
						 for (int k=0; k< borderLenght; k++)
						 {
							 if(nodeBaum[level][i,j,k].lastChange0>=nodeBaum[level][i,j,k].lastChange1)
							 {
								 Console.Write(+k+" "+"("+(nodeBaum[level][i,j,k].touchTimeStamp==nodeBaum[level][i,j,k].lastChange0)+") ");
							 }
							 else
							 {
								 Console.Write(+k+" "+"("+(nodeBaum[level][i,j,k].touchTimeStamp==nodeBaum[level][i,j,k].lastChange1)+") ");
							 }

                    
						 }
						 Console.WriteLine();
					 }
					 Console.WriteLine();
					 Console.ReadLine();
				 }
			 }

			 borderLenght = (int)System.Math.Pow(2,baumtiefe);
			 for (int i=0; i< borderLenght; i++)
			 {
            
				 for (int j=0; j< borderLenght; j++)
				 {
					 Console.Write(i+" "+j+" ");
					 for (int k=0; k< borderLenght; k++)
					 {
						 if((leafs[i,j,k].lastChange0==leafs[i,j,k].touchTimeStamp)
							 ||(leafs[i,j,k].lastChange1==leafs[i,j,k].touchTimeStamp) )
						 {
							 if(leafs[i,j,k].lastChange0>=leafs[i,j,k].lastChange1)
							 {
								 Console.Write(+k+" "+"("+(leafs[i,j,k].touchTimeStamp-7)+") ");
							 }
							 else
								 Console.Write(+k+" "+"("+(leafs[i,j,k].touchTimeStamp-7)+") ");
						 }
                    
					 }
					 Console.WriteLine();
				 }
				 Console.WriteLine();
				 Console.ReadLine();
			 }*/

			if(++runCounter==0)
			{
				runCounter=8;

				for(int level = 0; level<baumtiefe; level++)
				{
					borderLenght=(int)System.Math.Pow(2, level);

					for(int i = 0; i<borderLenght; i++)
					{
						for(int j = 0; j<borderLenght; j++)
						{
							for(int k = 0; k<borderLenght; k++)
							{
								nodeBaum[level][i, j, k].lastChange0=0;
								nodeBaum[level][i, j, k].lastChange1=7;
								nodeBaum[level][i, j, k].touchTimeStamp=7;
							}
						}
					}
				}

				borderLenght=(int)System.Math.Pow(2, baumtiefe);

				for(int i = 0; i<borderLenght; i++)
				{
					for(int j = 0; j<borderLenght; j++)
					{
						for(int k = 0; k<borderLenght; k++)
						{
							if(leafs[i, j, k].lastChange0>=leafs[i, j, k].lastChange1)
								leafs[i, j, k].state[1]=leafs[i, j, k].state[0];
							else
								leafs[i, j, k].state[0]=leafs[i, j, k].state[1];

							leafs[i, j, k].lastChange0=0;
							leafs[i, j, k].lastChange1=7;
							leafs[i, j, k].touchTimeStamp=7;
						}
					}
				}
			}

			return changed;
		}

		private byte MoveDown (int l, int x, int y, int z, ref bool changed)
		{
			int borderLenght = (int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			bool [,,] childs = new bool[2, 2, 2];
			ArrayList updRates = new ArrayList();
			bool changedB = false;

			if((runCounter%(nodeBaum[l][x, y, z]).updRate)==0)
			{
				if(!((nodeBaum[l][x, y, z].lastChange0==nodeBaum[l][x, y, z].touchTimeStamp) || 
					(nodeBaum[l][x, y, z].lastChange1==nodeBaum[l][x, y, z].touchTimeStamp)))
				{
					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibFace1[0])%borderLenght,
						(yo+neibFace1[1])%borderLenght,      (zo+neibFace1[2])%borderLenght))
					{
						childs[1, 0, 0]=true;
						childs[1, 0, 1]=true;
						childs[1, 1, 0]=true;
						childs[1, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibFace2[0])%borderLenght,
						(yo+neibFace2[1])%borderLenght,      (zo+neibFace2[2])%borderLenght))
					{
						childs[0, 0, 0]=true;
						childs[0, 0, 1]=true;
						childs[0, 1, 0]=true;
						childs[0, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibFace3[0])%borderLenght,
						(yo+neibFace3[1])%borderLenght,      (zo+neibFace3[2])%borderLenght))
					{
						childs[0, 1, 0]=true;
						childs[0, 1, 1]=true;
						childs[1, 1, 0]=true;
						childs[1, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibFace4[0])%borderLenght,
						(yo+neibFace4[1])%borderLenght,      (zo+neibFace4[2])%borderLenght))
					{
						childs[0, 0, 0]=true;
						childs[0, 0, 1]=true;
						childs[1, 0, 0]=true;
						childs[1, 0, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibFace5[0])%borderLenght,
						(yo+neibFace5[1])%borderLenght,      (zo+neibFace5[2])%borderLenght))
					{
						childs[0, 0, 1]=true;
						childs[0, 1, 1]=true;
						childs[1, 0, 1]=true;
						childs[1, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibFace6[0])%borderLenght,
						(yo+neibFace6[1])%borderLenght,      (zo+neibFace6[2])%borderLenght))
					{
						childs[0, 0, 0]=true;
						childs[0, 1, 0]=true;
						childs[1, 0, 0]=true;
						childs[1, 1, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor1[0])%borderLenght,
						(yo+neibBor1[1])%borderLenght,       (zo+neibBor1[2])%borderLenght))
					{
						childs[0, 1, 0]=true;
						childs[0, 0, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor2[0])%borderLenght,
						(yo+neibBor2[1])%borderLenght,       (zo+neibBor2[2])%borderLenght))
					{
						childs[0, 0, 1]=true;
						childs[0, 0, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor3[0])%borderLenght,
						(yo+neibBor3[1])%borderLenght,       (zo+neibBor3[2])%borderLenght))
					{
						childs[0, 1, 1]=true;
						childs[0, 0, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor4[0])%borderLenght,
						(yo+neibBor4[1])%borderLenght,       (zo+neibBor4[2])%borderLenght))
					{
						childs[0, 1, 0]=true;
						childs[0, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor5[0])%borderLenght,
						(yo+neibBor5[1])%borderLenght,       (zo+neibBor5[2])%borderLenght))
					{
						childs[1, 0, 0]=true;
						childs[1, 0, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor6[0])%borderLenght,
						(yo+neibBor6[1])%borderLenght,       (zo+neibBor6[2])%borderLenght))
					{
						childs[1, 0, 1]=true;
						childs[1, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor7[0])%borderLenght,
						(yo+neibBor7[1])%borderLenght,       (zo+neibBor7[2])%borderLenght))
					{
						childs[1, 0, 0]=true;
						childs[1, 1, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor8[0])%borderLenght,
						(yo+neibBor8[1])%borderLenght,       (zo+neibBor8[2])%borderLenght))
					{
						childs[1, 1, 0]=true;
						childs[1, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor9[0])%borderLenght,
						(yo+neibBor9[1])%borderLenght,       (zo+neibBor9[2])%borderLenght))
					{
						childs[0, 1, 1]=true;
						childs[1, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor10[0])%borderLenght,
						(yo+neibBor10[1])%borderLenght,      (zo+neibBor10[2])%borderLenght))
					{
						childs[0, 1, 0]=true;
						childs[1, 1, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor11[0])%borderLenght,
						(yo+neibBor11[1])%borderLenght,      (zo+neibBor11[2])%borderLenght))
					{
						childs[0, 0, 1]=true;
						childs[1, 0, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibBor12[0])%borderLenght,
						(yo+neibBor12[1])%borderLenght,      (zo+neibBor12[2])%borderLenght))
					{
						childs[0, 0, 0]=true;
						childs[1, 0, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibCor1[0])%borderLenght,
						(yo+neibCor1[1])%borderLenght,       (zo+neibCor1[2])%borderLenght))
					{
						childs[0, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibCor2[0])%borderLenght,
						(yo+neibCor2[1])%borderLenght,       (zo+neibCor2[2])%borderLenght))
					{
						childs[0, 1, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibCor3[0])%borderLenght,
						(yo+neibCor3[1])%borderLenght,       (zo+neibCor3[2])%borderLenght))
					{
						childs[0, 0, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibCor4[0])%borderLenght,
						(yo+neibCor4[1])%borderLenght,       (zo+neibCor4[2])%borderLenght))
					{
						childs[0, 0, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibCor5[0])%borderLenght,
						(yo+neibCor5[1])%borderLenght,       (zo+neibCor5[2])%borderLenght))
					{
						childs[1, 1, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibCor6[0])%borderLenght,
						(yo+neibCor6[1])%borderLenght,       (zo+neibCor6[2])%borderLenght))
					{
						childs[1, 1, 0]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibCor7[0])%borderLenght,
						(yo+neibCor7[1])%borderLenght,       (zo+neibCor7[2])%borderLenght))
					{
						childs[1, 0, 1]=true;
					}

					if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+neibCor8[0])%borderLenght,
						(yo+neibCor8[1])%borderLenght,       (zo+neibCor8[2])%borderLenght))
					{
						childs[1, 0, 0]=true;
					}
				}
				else
				{
					childs[0, 0, 0]=true;
					childs[0, 0, 1]=true;
					childs[0, 1, 0]=true;
					childs[0, 1, 1]=true;
					childs[1, 0, 0]=true;
					childs[1, 0, 1]=true;
					childs[1, 1, 0]=true;
					childs[1, 1, 1]=true;
				}

				if(l+1<baumtiefe)
				{
					if(childs[0, 0, 0])
					{
						changedB=false;
						updRates.Add(MoveDown(l+1, 2*x, 2*y, 2*z, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(nodeBaum[l+1][2*x, 2*y, 2*z].updRate);
					}

					if(childs[0, 0, 1])
					{
						changedB=false;
						updRates.Add(MoveDown(l+1, 2*x, 2*y, 2*z+1, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(nodeBaum[l+1][2*x, 2*y, 2*z+1].updRate);
					}

					if(childs[0, 1, 0])
					{
						changedB=false;
						updRates.Add(MoveDown(l+1, 2*x, 2*y+1, 2*z, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(nodeBaum[l+1][2*x, 2*y+1, 2*z].updRate);
					}

					if(childs[0, 1, 1])
					{
						changedB=false;
						updRates.Add(MoveDown(l+1, 2*x, 2*y+1, 2*z+1, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(nodeBaum[l+1][2*x, 2*y+1, 2*z+1].updRate);
					}

					if(childs[1, 0, 0])
					{
						changedB=false;
						updRates.Add(MoveDown(l+1, 2*x+1, 2*y, 2*z, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(nodeBaum[l+1][2*x+1, 2*y, 2*z].updRate);
					}

					if(childs[1, 0, 1])
					{
						changedB=false;
						updRates.Add(MoveDown(l+1, 2*x+1, 2*y, 2*z+1, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(nodeBaum[l+1][2*x+1, 2*y, 2*z+1].updRate);
					}

					if(childs[1, 1, 0])
					{
						changedB=false;
						updRates.Add(MoveDown(l+1, 2*x+1, 2*y+1, 2*z, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(nodeBaum[l+1][2*x+1, 2*y+1, 2*z].updRate);
					}

					if(childs[1, 1, 1])
					{
						changedB=false;
						updRates.Add(MoveDown(l+1, 2*x+1, 2*y+1, 2*z+1, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(nodeBaum[l+1][2*x+1, 2*y+1, 2*z+1].updRate);
					}

					updRates.Sort();
					nodeBaum[l][x, y, z].updRate=(byte)updRates[0];
					nodeBaum[l][x, y, z].touchTimeStamp=runCounter;

					if(changed)
					{
						if(nodeBaum[l][x, y, z].lastChange1>=nodeBaum[l][x, y, z].lastChange0)
							nodeBaum[l][x, y, z].lastChange0=runCounter;
						else
							nodeBaum[l][x, y, z].lastChange1=runCounter;
					}

					return (byte)updRates[0];
				}
				else
				{
					CellLeaf [,,] neigField = new CellLeaf[3, 3, 3];

					if(childs[0, 0, 0])
					{
						neighbourfield(2*x, 2*y, 2*z, ref neigField);
						changedB=false;
						updRates.Add(Update(ref neigField, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(leafs[2*x, 2*y, 2*z].updRate);
					}

					if(childs[0, 0, 1])
					{
						neighbourfield(2*x, 2*y, 2*z+1, ref neigField);
						changedB=false;
						updRates.Add(Update(ref neigField, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(leafs[2*x, 2*y, 2*z+1].updRate);
					}

					if(childs[0, 1, 0])
					{
						neighbourfield(2*x, 2*y+1, 2*z, ref neigField);
						changedB=false;
						updRates.Add(Update(ref neigField, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(leafs[2*x, 2*y+1, 2*z].updRate);
					}

					if(childs[0, 1, 1])
					{
						neighbourfield(2*x, 2*y+1, 2*z+1, ref neigField);
						changedB=false;
						updRates.Add(Update(ref neigField, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(leafs[2*x, 2*y+1, 2*z+1].updRate);
					}

					if(childs[1, 0, 0])
					{
						neighbourfield(2*x+1, 2*y, 2*z, ref neigField);
						changedB=false;
						updRates.Add(Update(ref neigField, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(leafs[2*x+1, 2*y, 2*z].updRate);
					}

					if(childs[1, 0, 1])
					{
						neighbourfield(2*x+1, 2*y, 2*z+1, ref neigField);
						changedB=false;
						updRates.Add(Update(ref neigField, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(leafs[2*x+1, 2*y, 2*z+1].updRate);
					}

					if(childs[1, 1, 0])
					{
						neighbourfield(2*x+1, 2*y+1, 2*z, ref neigField);
						changedB=false;
						updRates.Add(Update(ref neigField, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(leafs[2*x+1, 2*y+1, 2*z].updRate);
					}

					if(childs[1, 1, 1])
					{
						neighbourfield(2*x+1, 2*y+1, 2*z+1, ref neigField);
						changedB=false;
						updRates.Add(Update(ref neigField, ref changedB));
						changed=changed | changedB;
					}
					else
					{
						updRates.Add(leafs[2*x+1, 2*y+1, 2*z+1].updRate);
					}

					updRates.Sort();
					nodeBaum[l][x, y, z].updRate=(byte)updRates[0];
					nodeBaum[l][x, y, z].touchTimeStamp=runCounter;

					if(changed)
					{
						if(nodeBaum[l][x, y, z].lastChange1>=nodeBaum[l][x, y, z].lastChange0)
							nodeBaum[l][x, y, z].lastChange0=runCounter;
						else
							nodeBaum[l][x, y, z].lastChange1=runCounter;
					}

					return (byte)updRates[0];
				}
			}
			else
			{
				changed=true;
				return nodeBaum[l][x, y, z].updRate;
			}
		}

		private void neighbourfield (int x, int y, int z, ref CellLeaf [,,] neigField)
		{
			int borderLLeaf = (int)System.Math.Pow(2, baumtiefe);
			int xo = x+borderLLeaf;
			int yo = y+borderLLeaf;
			int zo = z+borderLLeaf;

			for(int i = -1; i<2; i++)
			{
				for(int j = -1; j<2; j++)
				{
					for(int k = -1; k<2; k++)
					{
						neigField[i+1, j+1, k+1]=leafs[(xo+i)%borderLLeaf, (yo+j)%borderLLeaf, (zo+k)%borderLLeaf];
					}
				}
			}
		}

		private bool NodeNeighbourChanged (ushort MeTTS, int l, int x, int y, int z)
		{
			if(((runCounter>nodeBaum[l][x, y, z].lastChange0) && (nodeBaum[l][ x, y, z].lastChange0>=MeTTS))
				|| ((runCounter>nodeBaum[l][x, y, z].lastChange1) && (nodeBaum[l][x, y, z].lastChange1>=MeTTS)))
				return true;
			else
				return false;
		}

		private int LeafDataIndexActiv (ref CellLeaf [,,] neigField, int x, int y, int z)
		{
			if(neigField[x, y, z].touchTimeStamp==runCounter)
			{
				if(neigField[x, y, z].lastChange0>=neigField[x, y, z].lastChange1)
					return 1;
				else
					return 0;
			}
			else
			{
				if(neigField[x, y, z].lastChange0>=neigField[x, y, z].lastChange1)
					return 0;
				else
					return 1;
			}
		}

		private byte Update (ref CellLeaf [,,] neigField, ref bool changed)
		{/*
			if((runCounter%neigField[1, 1, 1].updRate)==0)
			{
				int count = 0;

				for(int i = 0; i<3; i++)
					for(int j = 0; j<3; j++)
						for(int k = 0; k<3; k++)
						{
							if(neigField[i, j, k].state[LeafDataIndexActiv(ref neigField, i, j, k)])
							{
								count++;
							}
						}
			

				if(count>0)
				{
					neigField[1, 1, 1].state[(LeafDataIndexActiv(ref neigField, 1, 1, 1)+1)%2]=true;

					if(!neigField[1, 1, 1].state[LeafDataIndexActiv(ref neigField, 1, 1, 1)])
					{
						neigField[1, 1, 1].updRate=1;
						changed=true;

						if(neigField[1, 1, 1].lastChange0<=neigField[1, 1, 1].lastChange1)
							neigField[1, 1, 1].lastChange0=runCounter;
						else
							neigField[1, 1, 1].lastChange0=runCounter;
					}
					else
					{
						changed=false;
					}

					neigField[1, 1, 1].touchTimeStamp=runCounter;
					return 1;
				}
				else
				{
					neigField[1, 1, 1].updRate=1;
					changed=false;
					neigField[1, 1, 1].touchTimeStamp=runCounter;
					return neigField[1, 1, 1].updRate;
				}
			}
			else
			{
				changed=true;
				return neigField[1, 1, 1].updRate;
			}*/

			
			if((runCounter%neigField[1, 1, 1].updRate)==0)
			{	
				if(neigField[0, 2, 0].state[LeafDataIndexActiv(ref neigField, 0, 2, 0)])
				{
					neigField[1, 1, 1].state[(LeafDataIndexActiv(ref neigField, 1, 1, 1)+1)%2]=true;
					if(!neigField[1, 1, 1].state[LeafDataIndexActiv(ref neigField, 1, 1, 1)])
					{
						neigField[1, 1, 1].updRate=1;
						changed=true;

						if(neigField[1, 1, 1].lastChange0<=neigField[1, 1, 1].lastChange1)
							neigField[1, 1, 1].lastChange0=runCounter;
						else
							neigField[1, 1, 1].lastChange0=runCounter;
					}
					else
					{
						changed=false;
					}

					neigField[1, 1, 1].touchTimeStamp=runCounter;
					return 1;
				}
				else
				{
					if(!neigField[0, 2, 0].state[LeafDataIndexActiv(ref neigField, 0, 2, 0)])
					{
						neigField[1, 1, 1].state[(LeafDataIndexActiv(ref neigField, 1, 1, 1)+1)%2]=false;
						if(neigField[1, 1, 1].state[LeafDataIndexActiv(ref neigField, 1, 1, 1)])
						{
							neigField[1, 1, 1].updRate=1;
							changed=true;

							if(neigField[1, 1, 1].lastChange0<=neigField[1, 1, 1].lastChange1)
								neigField[1, 1, 1].lastChange0=runCounter;
							else
								neigField[1, 1, 1].lastChange0=runCounter;
						}
						else
						{
							changed=false;
						}

						neigField[1, 1, 1].touchTimeStamp=runCounter;
						return 1;
					}
					else
					{
						neigField[1, 1, 1].updRate=1;
						changed=false;
						neigField[1, 1, 1].touchTimeStamp=runCounter;
						return neigField[1, 1, 1].updRate;

					}
				}

		

				
				
		
			
			}
			else
			{
				changed=true;
				return neigField[1, 1, 1].updRate;
			}
		}
	}
}
