using System;
using System.Collections;
using System.Reflection;

namespace TableTree
{
/// <summary>
/// Zusammenfassung fr TableTree.
/// </summary>
/// 

public abstract class TableTree
{
    private delegate void NeibConnectios (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                          bool [,,] childs);

    public enum Direction : byte
        {
        Left,
        Right,
        Top,
        Botton,
        Back,
        Front,
        BordLeftTop,
        BordLeftFront,
        BordLeftBotton,
        BordLeftBack,
        BordTopBack,
        BordTopFront,
        BordBottonFront,
        BordBottonBack,
        BordRightTop,
        BordRightFront,
        BordRightBotton,
        BordRightBack,
        CorLeftTopBack,
        CornLeftTopFront,
        CorLeftBottonFront,
        CorLeftBottonBack,
        CorRightTopBack,
        CroRightTopFront,
        CorRightBottonFront,
        CorRightBottonBack
        };

    private enum Color : byte
        {
        invisible0 = 0,
        invisible1 = 1,
        red = 2,
        blue = 3,
        green = 4,
        yellow = 5,
        black = 6,
        white = 7
        };

    public ushort runCounter = 8;
    public CellNode [] [,,] nodeBaum;
    public CellLeaf [,,] leafs;
    public int baumtiefe = 0;
    private CellLeaf [,,] neigField;

    private NeibConnectios conections;

    public byte RightNeibState
    {
        get
        {
            return neigField[0, 1, 1].state[LeafDataIndexActiv(ref neigField, 0, 1, 1)];
        }
    }

    public byte LeftNeibState
    {
        get
        {
            return neigField[2, 1, 1].state[LeafDataIndexActiv(ref neigField, 2, 1, 1)];
        }
    }

    public byte BottonNeibState
    {
        get
        {
            return neigField[1, 0, 1].state[LeafDataIndexActiv(ref neigField, 1, 0, 1)];
        }
    }

    public byte TopNeibState
    {
        get
        {
            return neigField[1, 2, 1].state[LeafDataIndexActiv(ref neigField, 1, 2, 1)];
        }
    }

    public byte FrontNeibState
    {
        get
        {
            return neigField[2, 1, 1].state[LeafDataIndexActiv(ref neigField, 1, 1, 0)];
        }
    }

    public byte BackNeibState
    {
        get
        {
            return neigField[1, 1, 2].state[LeafDataIndexActiv(ref neigField, 1, 1, 2)];
        }
    }

    public byte BordBottonFrontNeibState
    {
        get
        {
            return neigField[1, 0, 0].state[LeafDataIndexActiv(ref neigField, 1, 0, 0)];
        }
    }

    public byte BordBottonBackNeibState
    {
        get
        {
            return neigField[1, 0, 2].state[LeafDataIndexActiv(ref neigField, 1, 0, 2)];
        }
    }

    public byte BordTopFrontNeibState
    {
        get
        {
            return neigField[1, 2, 0].state[LeafDataIndexActiv(ref neigField, 1, 2, 0)];
        }
    }

    public byte BordTopBackNeibState
    {
        get
        {
            return neigField[1, 2, 2].state[LeafDataIndexActiv(ref neigField, 1, 2, 2)];
        }
    }

    public byte BordLeftFrontNeibState
    {
        get
        {
            return neigField[0, 1, 0].state[LeafDataIndexActiv(ref neigField, 0, 1, 0)];
        }
    }

    public byte BordLeftBackeNeibState
    {
        get
        {
            return neigField[0, 1, 2].state[LeafDataIndexActiv(ref neigField, 0, 1, 2)];
        }
    }

    public byte BordRightFrontNeibState
    {
        get
        {
            return neigField[2, 1, 0].state[LeafDataIndexActiv(ref neigField, 2, 1, 0)];
        }
    }

    public byte BordRightBackNeibState
    {
        get
        {
            return neigField[2, 1, 2].state[LeafDataIndexActiv(ref neigField, 2, 1, 2)];
        }
    }

    public byte BordLeftBottonNeibState
    {
        get
        {
            return neigField[0, 0, 1].state[LeafDataIndexActiv(ref neigField, 0, 0, 1)];
        }
    }

    public byte BordLeftTopNeibState
    {
        get
        {
            return neigField[0, 2, 1].state[LeafDataIndexActiv(ref neigField, 0, 2, 1)];
        }
    }

    public byte BordRightBottonNeibState
    {
        get
        {
            return neigField[2, 0, 1].state[LeafDataIndexActiv(ref neigField, 2, 0, 1)];
        }
    }

    public byte BordRightTopNeibState
    {
        get
        {
            return neigField[2, 2, 1].state[LeafDataIndexActiv(ref neigField, 2, 2, 1)];
        }
    }

    public byte CornLeftBottonFrontNeibState
    {
        get
        {
            return neigField[0, 0, 2].state[LeafDataIndexActiv(ref neigField, 0, 0, 2)];
        }
    }

    public byte CornLeftBottonBackNeibState
    {
        get
        {
            return neigField[0, 0, 2].state[LeafDataIndexActiv(ref neigField, 0, 0, 2)];
        }
    }

    public byte CornLeftTopFrontNeibState
    {
        get
        {
            return neigField[0, 2, 0].state[LeafDataIndexActiv(ref neigField, 0, 2, 0)];
        }
    }

    public byte CornLeftTopBackNeibState
    {
        get
        {
            return neigField[0, 2, 2].state[LeafDataIndexActiv(ref neigField, 0, 2, 2)];
        }
    }

    public byte CornRightBottonBackNeibState
    {
        get
        {
            return neigField[2, 0, 0].state[LeafDataIndexActiv(ref neigField, 2, 0, 0)];
        }
    }

    public byte CornRightBottonFrontNeibState
    {
        get
        {
            return neigField[2, 0, 2].state[LeafDataIndexActiv(ref neigField, 2, 0, 2)];
        }
    }

    public byte CornRightTopBackNeibState
    {
        get
        {
            return neigField[2, 2, 0].state[LeafDataIndexActiv(ref neigField, 2, 2, 0)];
        }
    }

    public byte CornRightTopFrontNeibState
    {
        get
        {
            return neigField[2, 2, 2].state[LeafDataIndexActiv(ref neigField, 2, 2, 2)];
        }
    }

    public TableTree (int baumtiefe)
    {
        int borderLenght;
        this.baumtiefe=baumtiefe;
        nodeBaum=new CellNode[baumtiefe][,,];
        SetNeibConnections(GiveUsedNeibDirection());

        for(int level = 0; level<this.baumtiefe; level++)
        {
            borderLenght=(int)System.Math.Pow(2, level);
            nodeBaum[level]=new CellNode[borderLenght, borderLenght, borderLenght];

            for(int i = 0; i<borderLenght; i++)
            {
                for(int j = 0; j<borderLenght; j++)
                {
                    for(int k = 0; k<borderLenght; k++)
                    {
                        nodeBaum[level][i, j, k]=new CellNode();
                    }
                }
            }
        }

        borderLenght=(int)System.Math.Pow(2, this.baumtiefe);
        leafs=new CellLeaf[borderLenght, borderLenght, borderLenght];

        for(int i = 0; i<borderLenght; i++)
        {
            for(int j = 0; j<borderLenght; j++)
            {
                for(int k = 0; k<borderLenght; k++)
                {
                    leafs[i, j, k]=new CellLeaf();
                }
            }
        }
    }

    private void SetNeibConnections (byte []directions)
    {
        foreach(byte direction in directions)
        {
            if(direction==0)
                conections+=new NeibConnectios(CheckNeiBLeft);

            if(direction==1)
                conections+=new NeibConnectios(CheckNeiBRight);

            if(direction==2)
                conections+=new NeibConnectios(CheckNeiBTop);

            if(direction==3)
                conections+=new NeibConnectios(CheckNeiBBotton);

            if(direction==4)
                conections+=new NeibConnectios(CheckNeiBBack);

            if(direction==5)
                conections+=new NeibConnectios(CheckNeiBFront);

            if(direction==6)
                conections+=new NeibConnectios(CheckNeiBBordLeftTop);

            if(direction==7)
                conections+=new NeibConnectios(CheckNeiBBordLeftFront);

            if(direction==8)
                conections+=new NeibConnectios(CheckNeiBBordLeftBotton);

            if(direction==9)
                conections+=new NeibConnectios(CheckNeiBBordLeftBack);

            if(direction==10)
                conections+=new NeibConnectios(CheckNeiBBordTopBack);

            if(direction==11)
                conections+=new NeibConnectios(CheckNeiBBordTopFront);

            if(direction==12)
                conections+=new NeibConnectios(CheckNeiBBordBottonFront);

            if(direction==13)
                conections+=new NeibConnectios(CheckNeiBBordBottonBack);

            if(direction==14)
                conections+=new NeibConnectios(CheckNeiBBordRightTop);

            if(direction==15)
                conections+=new NeibConnectios(CheckNeiBBordRightFront);

            if(direction==16)
                conections+=new NeibConnectios(CheckNeiBBordRightBotton);

            if(direction==17)
                conections+=new NeibConnectios(CheckNeiBBordRightBack);

            if(direction==18)
                conections+=new NeibConnectios(CheckNeiBCorLeftTopBack);

            if(direction==19)
                conections+=new NeibConnectios(CheckNeiBCornLeftTopFront);

            if(direction==20)
                conections+=new NeibConnectios(CheckNeiBCorLeftBottonFront);

            if(direction==21)
                conections+=new NeibConnectios(CheckNeiBCorLeftBottonBack);

            if(direction==22)
                conections+=new NeibConnectios(CheckNeiBCorRightTopBack);

            if(direction==23)
                conections+=new NeibConnectios(CheckNeiBCroRightTopFront);

            if(direction==24)
                conections+=new NeibConnectios(CheckNeiBCorRightBottonFront);

            if(direction==25)
                conections+=new NeibConnectios(CheckNeiBCorRightBottonBack);
        }
    }

    public bool CycleStart ()
    {
        int borderLenght;
        bool changed = false;
        Win32.HiPerfTimer timmer = new Win32.HiPerfTimer();
        timmer.Start();

        MoveDown(0, 0, 0, 0, ref changed);
        timmer.Stop();
        Console.WriteLine("zeit: "+timmer.Duration);

        //Console.ReadLine();
        if(++runCounter==0)
        {
            runCounter=8;

            for(int level = 0; level<baumtiefe; level++)
            {
                borderLenght=(int)System.Math.Pow(2, level);

                for(int i = 0; i<borderLenght; i++)
                {
                    for(int j = 0; j<borderLenght; j++)
                    {
                        for(int k = 0; k<borderLenght; k++)
                        {
                            nodeBaum[level][i, j, k].lastChange0=0;
                            nodeBaum[level][i, j, k].lastChange1=7;
                            nodeBaum[level][i, j, k].touchTimeStamp=7;
                        }
                    }
                }
            }
        }

        return changed;
    }

    public byte MoveDown (int l, int x, int y, int z, ref bool changed)
    {
        int borderLenght = (int)System.Math.Pow(2, l);
        int xo = x+borderLenght;
        int yo = y+borderLenght;
        int zo = z+borderLenght;
        bool [,,] childs = new bool[2, 2, 2];
        ArrayList updRates = new ArrayList();
        bool changedB = false;

        if((runCounter%(nodeBaum[l][x, y, z]).updRate)==0)
        {
            if(!((nodeBaum[l][x,
            y,
            z].lastChange0==nodeBaum[l][x,
            y,
            z].touchTimeStamp) || (nodeBaum[l][x,
            y,
            z].lastChange1==nodeBaum[l][x,
            y,
            z].touchTimeStamp)))
            {
                conections(x, y, z, xo, yo, zo, borderLenght, l, childs);
            }
            else
            {
                childs[0, 0, 0]=true;
                childs[0, 0, 1]=true;
                childs[0, 1, 0]=true;
                childs[0, 1, 1]=true;
                childs[1, 0, 0]=true;
                childs[1, 0, 1]=true;
                childs[1, 1, 0]=true;
                childs[1, 1, 1]=true;
            }

            if(l+1<baumtiefe)
            {
                if(childs[0, 0, 0])
                {
                    changedB=false;
                    updRates.Add(MoveDown(l+1, 2*x, 2*y, 2*z, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(nodeBaum[l+1][2*x, 2*y, 2*z].updRate);
                }

                if(childs[0, 0, 1])
                {
                    changedB=false;
                    updRates.Add(MoveDown(l+1, 2*x, 2*y, 2*z+1, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(nodeBaum[l+1][2*x, 2*y, 2*z+1].updRate);
                }

                if(childs[0, 1, 0])
                {
                    changedB=false;
                    updRates.Add(MoveDown(l+1, 2*x, 2*y+1, 2*z, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(nodeBaum[l+1][2*x, 2*y+1, 2*z].updRate);
                }

                if(childs[0, 1, 1])
                {
                    changedB=false;
                    updRates.Add(MoveDown(l+1, 2*x, 2*y+1, 2*z+1, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(nodeBaum[l+1][2*x, 2*y+1, 2*z+1].updRate);
                }

                if(childs[1, 0, 0])
                {
                    changedB=false;
                    updRates.Add(MoveDown(l+1, 2*x+1, 2*y, 2*z, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(nodeBaum[l+1][2*x+1, 2*y, 2*z].updRate);
                }

                if(childs[1, 0, 1])
                {
                    changedB=false;
                    updRates.Add(MoveDown(l+1, 2*x+1, 2*y, 2*z+1, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(nodeBaum[l+1][2*x+1, 2*y, 2*z+1].updRate);
                }

                if(childs[1, 1, 0])
                {
                    changedB=false;
                    updRates.Add(MoveDown(l+1, 2*x+1, 2*y+1, 2*z, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(nodeBaum[l+1][2*x+1, 2*y+1, 2*z].updRate);
                }

                if(childs[1, 1, 1])
                {
                    changedB=false;
                    updRates.Add(MoveDown(l+1, 2*x+1, 2*y+1, 2*z+1, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(nodeBaum[l+1][2*x+1, 2*y+1, 2*z+1].updRate);
                }

                updRates.Sort();
                nodeBaum[l][x, y, z].updRate=(byte)updRates[0];
                nodeBaum[l][x, y, z].touchTimeStamp=runCounter;

                if(changed)
                {
                    if(nodeBaum[l][x, y, z].lastChange1>=nodeBaum[l][x, y, z].lastChange0)
                        nodeBaum[l][x, y, z].lastChange0=runCounter;
                    else
                        nodeBaum[l][x, y, z].lastChange1=runCounter;
                }

                return (byte)updRates[0];
            }
            else
            {
                CellLeaf [,,] neigField = new CellLeaf[3, 3, 3];

                if(childs[0, 0, 0])
                {
                    neighbourfield(2*x, 2*y, 2*z, ref neigField);
                    changedB=false;
                    updRates.Add(UpdateState(ref neigField, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(leafs[2*x, 2*y, 2*z].updRate);
                }

                if(childs[0, 0, 1])
                {
                    neighbourfield(2*x, 2*y, 2*z+1, ref neigField);
                    changedB=false;
                    updRates.Add(UpdateState(ref neigField, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(leafs[2*x, 2*y, 2*z+1].updRate);
                }

                if(childs[0, 1, 0])
                {
                    neighbourfield(2*x, 2*y+1, 2*z, ref neigField);
                    changedB=false;
                    updRates.Add(UpdateState(ref neigField, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(leafs[2*x, 2*y+1, 2*z].updRate);
                }

                if(childs[0, 1, 1])
                {
                    neighbourfield(2*x, 2*y+1, 2*z+1, ref neigField);
                    changedB=false;
                    updRates.Add(UpdateState(ref neigField, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(leafs[2*x, 2*y+1, 2*z+1].updRate);
                }

                if(childs[1, 0, 0])
                {
                    neighbourfield(2*x+1, 2*y, 2*z, ref neigField);
                    changedB=false;
                    updRates.Add(UpdateState(ref neigField, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(leafs[2*x+1, 2*y, 2*z].updRate);
                }

                if(childs[1, 0, 1])
                {
                    neighbourfield(2*x+1, 2*y, 2*z+1, ref neigField);
                    changedB=false;
                    updRates.Add(UpdateState(ref neigField, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(leafs[2*x+1, 2*y, 2*z+1].updRate);
                }

                if(childs[1, 1, 0])
                {
                    neighbourfield(2*x+1, 2*y+1, 2*z, ref neigField);
                    changedB=false;
                    updRates.Add(UpdateState(ref neigField, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(leafs[2*x+1, 2*y+1, 2*z].updRate);
                }

                if(childs[1, 1, 1])
                {
                    neighbourfield(2*x+1, 2*y+1, 2*z+1, ref neigField);
                    changedB=false;
                    updRates.Add(UpdateState(ref neigField, ref changedB));
                    changed=changed | changedB;
                }
                else
                {
                    updRates.Add(leafs[2*x+1, 2*y+1, 2*z+1].updRate);
                }

                updRates.Sort();
                nodeBaum[l][x, y, z].updRate=(byte)updRates[0];
                nodeBaum[l][x, y, z].touchTimeStamp=runCounter;

                if(changed)
                {
                    if(nodeBaum[l][x, y, z].lastChange1>=nodeBaum[l][x, y, z].lastChange0)
                        nodeBaum[l][x, y, z].lastChange0=runCounter;
                    else
                        nodeBaum[l][x, y, z].lastChange1=runCounter;
                }

                return (byte)updRates[0];
            }
        }
        else
        {
            changed=true;
            return nodeBaum[l][x, y, z].updRate;
        }
    }

    private void CheckNeiBRight (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo)%borderLenght,
                                (zo)%borderLenght))
        {
            childs[1, 0, 0]=true;
            childs[1, 0, 1]=true;
            childs[1, 1, 0]=true;
            childs[1, 1, 1]=true;
        }
    }

    private void CheckNeiBLeft (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo)%borderLenght,
                                (zo)%borderLenght))
        {
            childs[0, 0, 0]=true;
            childs[0, 0, 1]=true;
            childs[0, 1, 0]=true;
            childs[0, 1, 1]=true;
        }
    }

    private void CheckNeiBTop (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght, (yo+1)%borderLenght,
                                (zo)%borderLenght))
        {
            childs[0, 1, 0]=true;
            childs[0, 1, 1]=true;
            childs[1, 1, 0]=true;
            childs[1, 1, 1]=true;
        }
    }

    private void CheckNeiBBotton (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                  bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght, (yo-1)%borderLenght,
                                (zo)%borderLenght))
        {
            childs[0, 0, 0]=true;
            childs[0, 0, 1]=true;
            childs[1, 0, 0]=true;
            childs[1, 0, 1]=true;
        }
    }

    private void CheckNeiBBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght, (yo)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[0, 0, 1]=true;
            childs[0, 1, 1]=true;
            childs[1, 0, 1]=true;
            childs[1, 1, 1]=true;
        }
    }

    private void CheckNeiBFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght, (yo)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[0, 0, 0]=true;
            childs[0, 1, 0]=true;
            childs[1, 0, 0]=true;
            childs[1, 1, 0]=true;
        }
    }

    private void CheckNeiBBordLeftFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                         bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[0, 1, 0]=true;
            childs[0, 0, 0]=true;
        }
    }

    private void CheckNeiBBordLeftBotton (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                          bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo-1)%borderLenght,
                                (zo)%borderLenght))
        {
            childs[0, 0, 1]=true;
            childs[0, 0, 0]=true;
        }
    }

    private void CheckNeiBBordLeftBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                        bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[0, 1, 1]=true;
            childs[0, 0, 1]=true;
        }
    }

    private void CheckNeiBBordLeftTop (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                       bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo+1)%borderLenght,
                                (zo)%borderLenght))
        {
            childs[0, 1, 0]=true;
            childs[0, 1, 1]=true;
        }
    }

    private void CheckNeiBBordRightBotton (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                           bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo-1)%borderLenght,
                                (zo)%borderLenght))
        {
            childs[1, 0, 0]=true;
            childs[1, 0, 1]=true;
        }
    }

    private void CheckNeiBBordRightBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                         bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[1, 0, 1]=true;
            childs[1, 1, 1]=true;
        }
    }

    private void CheckNeiBBordRightFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                          bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[1, 0, 0]=true;
            childs[1, 1, 0]=true;
        }
    }

    private void CheckNeiBBordRightTop (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                        bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo+1)%borderLenght,
                                (zo)%borderLenght))
        {
            childs[1, 1, 0]=true;
            childs[1, 1, 1]=true;
        }
    }

    private void CheckNeiBBordTopBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                       bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght, (yo+1)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[0, 1, 1]=true;
            childs[1, 1, 1]=true;
        }
    }

    private void CheckNeiBBordTopFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                        bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght, (yo+1)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[0, 1, 0]=true;
            childs[1, 1, 0]=true;
        }
    }

    private void CheckNeiBBordBottonBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                          bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght, (yo-1)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[0, 0, 1]=true;
            childs[1, 0, 1]=true;
        }
    }

    private void CheckNeiBBordBottonFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                           bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo)%borderLenght, (yo-1)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[0, 0, 0]=true;
            childs[1, 0, 0]=true;
        }
    }

    private void CheckNeiBCorLeftTopBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                          bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo+1)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[0, 1, 1]=true;
        }
    }

    private void CheckNeiBCornLeftTopFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                            bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo+1)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[0, 1, 0]=true;
        }
    }

    private void CheckNeiBCorLeftBottonBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                             bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo-1)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[0, 0, 1]=true;
        }
    }

    private void CheckNeiBCorLeftBottonFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                              bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo-1)%borderLenght, (yo-1)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[0, 0, 0]=true;
        }
    }

    private void CheckNeiBCorRightTopBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                           bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo+1)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[1, 1, 1]=true;
        }
    }

    private void CheckNeiBCroRightTopFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                            bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo+1)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[1, 1, 0]=true;
        }
    }

    private void CheckNeiBCorRightBottonBack (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                              bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo-1)%borderLenght,
                                (zo+1)%borderLenght))
        {
            childs[1, 0, 1]=true;
        }
    }

    private void CheckNeiBCorRightBottonFront (int x, int y, int z, int xo, int yo, int zo, int borderLenght, int l,
                                               bool [,,] childs)
    {
        if(NodeNeighbourChanged(nodeBaum[l][x, y, z].touchTimeStamp, l, (xo+1)%borderLenght, (yo-1)%borderLenght,
                                (zo-1)%borderLenght))
        {
            childs[1, 0, 0]=true;
        }
    }

    private void neighbourfield (int x, int y, int z, ref CellLeaf [,,] neigField)
    {
        int borderLLeaf = (int)System.Math.Pow(2, baumtiefe);
        int xo = x+borderLLeaf;
        int yo = y+borderLLeaf;
        int zo = z+borderLLeaf;

        for(int i = -1; i<2; i++)
        {
            for(int j = -1; j<2; j++)
            {
                for(int k = -1; k<2; k++)
                {
                    neigField[i+1, j+1, k+1]=leafs[(xo+i)%borderLLeaf, (yo+j)%borderLLeaf, (zo+k)%borderLLeaf];
                }
            }
        }
    }

    private bool NodeNeighbourChanged (ushort MeTTS, int l, int x, int y, int z)
    {
        if(((runCounter>nodeBaum[l][x,y,z].lastChange0) && (nodeBaum[l][x,y, z].lastChange0>=MeTTS)) || 
			((runCounter>nodeBaum[l][x,y,z].lastChange1) && (nodeBaum[l][x, y, z].lastChange1>=MeTTS)))
            return true;
        else
            return false;
    }

    private byte UpdateState (ref CellLeaf [,,] neigField, ref bool changed)
    {
        if((runCounter%neigField[1, 1, 1].updRate)==0)
        {
            this.neigField=neigField;
            this.runCounter=runCounter;
            byte newstate = 0;
            byte updRate = Rules(ref newstate, neigField[1, 1, 1].state[(LeafDataIndexActiv(ref neigField, 1, 1, 1))]);
            return SetState(newstate, updRate, ref changed);
        }

        return neigField[1, 1, 1].updRate;
    }

    public int CountNeibWhiteState (byte state)
    {
        int count = 0;

        for(int i = 0; i<3; i++)
            for(int j = 0; j<3; j++)
                for(int k = 0; k<3; k++)
                {
                    if(neigField[i, j, k].state[LeafDataIndexActiv(ref neigField, i, j, k)]==state)
                    {
                        count++;
                    }
                }

        return count;
    }

    private byte SetState (byte state, byte updRateNeu, ref bool changed)
    {
        neigField[1, 1, 1].state[(LeafDataIndexActiv(ref neigField, 1, 1, 1)+1)%2]=(byte)state;

        if(neigField[1, 1, 1].state[LeafDataIndexActiv(ref neigField, 1, 1, 1)]!=state)
        {
            neigField[1, 1, 1].updRate=updRateNeu;
            changed=true;

            if(neigField[1, 1, 1].lastChange0<=neigField[1, 1, 1].lastChange1)
                neigField[1, 1, 1].lastChange0=runCounter;
            else
                neigField[1, 1, 1].lastChange0=runCounter;
        }
        else
        {
            changed=false;
        }

        neigField[1, 1, 1].touchTimeStamp=runCounter;
        return updRateNeu;
    }

    private int LeafDataIndexActiv (ref CellLeaf [,,] neigField, int x, int y, int z)
    {
        if(neigField[x, y, z].touchTimeStamp==runCounter)
        {
            if(neigField[x, y, z].lastChange0>=neigField[x, y, z].lastChange1)
                return 1;
            else
                return 0;
        }
        else
        {
            if(neigField[x, y, z].lastChange0>=neigField[x, y, z].lastChange1)
                return 0;
            else
                return 1;
        }
    }

    private void AusgabeLeafs ()
    {
        int borderLenght = (int)System.Math.Pow(2, baumtiefe);

        for(int i = 0; i<borderLenght; i++)
        {
            for(int j = 0; j<borderLenght; j++)
            {
                Console.Write(i+" "+j+" ");

                for(int k = 0; k<borderLenght; k++)
                {
                    if((leafs[i,
                              j,
                              k].lastChange0==leafs[i,
                                                    j,
                                                    k].touchTimeStamp) || (leafs[i,
                                                                                 j,
                                                                                 k].lastChange1==leafs[i,
                                                                                                       j,
                                                                                                       k].touchTimeStamp))
                    {
                        if(leafs[i, j, k].lastChange0>=leafs[i, j, k].lastChange1)
                        {
                            Console.Write(+k+" "+"("+(leafs[i, j, k].touchTimeStamp-7)+") ");
                        }
                        else
                            Console.Write(+k+" "+"("+(leafs[i, j, k].touchTimeStamp-7)+") ");
                    }
                }

                Console.WriteLine();
            }

            Console.WriteLine();
            Console.ReadLine();
        }
    }

    private void AusgabeNodes ()
    {
        for(int level = 0; level<baumtiefe; level++)
        {
            int borderLenght = (int)System.Math.Pow(2, level);

            for(int i = 0; i<borderLenght; i++)
            {
                for(int j = 0; j<borderLenght; j++)
                {
                    Console.Write(level+" "+i+" "+j+" ");

                    for(int k = 0; k<borderLenght; k++)
                    {
                        if(nodeBaum[level][i, j, k].lastChange0>=nodeBaum[level][i, j, k].lastChange1)
                        {
                            Console.Write(+k+" "+"("+(nodeBaum[level][
                                                      i,
                                                      j,
                                                      k].touchTimeStamp==nodeBaum[level][i, j, k].lastChange0)+") ");
                        }
                        else
                        {
                            Console.Write(+k+" "+"("+(nodeBaum[level][
                                                      i,
                                                      j,
                                                      k].touchTimeStamp==nodeBaum[level][i, j, k].lastChange1)+") ");
                        }
                    }

                    Console.WriteLine();
                }

                Console.WriteLine();
                Console.ReadLine();
            }
        }
    }

    abstract public byte Rules (ref byte state, byte currentstate);

    abstract public byte []GiveUsedNeibDirection ();
}
}
