using System;
using System.Collections;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace TableTree
{
	/// <summary>
	/// Zusammenfassung fr TableTree.
	/// </summary>
	/// 

	public class TableTree
	{
		public uint runCounter = 0;
		public CellNode [] [,,] nodeBaum;
		//public CellLeaf [,,] leafs;
		public byte[,,] lstate;
		public CellNode [] [,,] nodeBaumBack;
		public CellLeaf [,,] leafsBack;
		byte[,,] lstateBack;
		public int baumtiefe = 0;
		int borderLenght;
		uint current;
		uint neu;

		int []neibCor1 =
	{
		-1,
		1,
		1
	};

		int []neibCor2 =
	{
		-1,
		1,
		-1
	};

		int []neibCor3 =
	{
		-1,
		-1,
		1
	};

		int []neibCor4 =
	{
		-1,
		-1,
		-1
	};

		int []neibCor5 =
	{
		1,
		1,
		1
	};

		int []neibCor6 =
	{
		1,
		1,
		-1
	};

		int []neibCor7 =
	{
		1,
		-1,
		1
	};

		int []neibCor8 =
	{
		1,
		-1,
		-1
	};

		// Nachbarn an den Kanten
		int []neibBor1 =
	{
		-1,
		0,
		-1
	};

		int []neibBor2 =
	{
		-1,
		-1,
		0
	};

		int []neibBor3 =
	{
		-1,
		0,
		1
	};

		int []neibBor4 =
	{
		-1,
		1,
		0
	};

		int []neibBor5 =
	{
		1,
		-1,
		0
	};

		int []neibBor6 =
	{
		1,
		0,
		1
	};

		int []neibBor7 =
	{
		1,
		0,
		-1
	};

		int []neibBor8 =
	{
		1,
		1,
		0
	};

		int []neibBor9 =
	{
		0,
		1,
		1
	};

		int []neibBor10 =
	{
		0,
		1,
		-1
	};

		int []neibBor11 =
	{
		0,
		-1,
		1
	};

		int []neibBor12 =
	{
		0,
		-1,
		-1
	};

		//Flchen
		int []neibFace1 =
	{
		1,
		0,
		0
	};

		int []neibFace2 =
	{
		-1,
		0,
		0
	};

		int []neibFace3 =
	{
		0,
		1,
		0
	};

		int []neibFace4 =
	{
		0,
		-1,
		0
	};

		int []neibFace5 =
	{
		0,
		0,
		1
	};

		int []neibFace6 =
	{
		0,
		0,
		-1
	};

		public TableTree (int baumtiefe)
		{
			this.baumtiefe=baumtiefe;
			nodeBaum=new CellNode[baumtiefe][,,];

			for(int level = 0; level<this.baumtiefe; level++)
			{
				borderLenght=(int)System.Math.Pow(2, level);
				nodeBaum[level]=new CellNode[borderLenght, borderLenght, borderLenght];

				for(int i = 0; i<borderLenght; i++)
				{
					for(int j = 0; j<borderLenght; j++)
					{
						for(int k = 0; k<borderLenght; k++)
						{
							nodeBaum[level][i, j, k].changed=true;
						}
					}
				}
			}

			borderLenght=(int)System.Math.Pow(2, this.baumtiefe);
			lstate=new byte[borderLenght, borderLenght, borderLenght];

			for(int i = 0; i<borderLenght; i++)
			{
				for(int j = 0; j<borderLenght; j++)
				{
					for(int k = 0; k<borderLenght; k++)
					{
						lstate[i, j, k]=0;
					}
				}
			}
		}

		public bool CycleStart ()
		{
			bool changed = false;

			lstateBack=(byte [,,] )lstate.Clone();
			nodeBaumBack=new CellNode[baumtiefe][,,];

			for(int level = 0; level<this.baumtiefe; level++)
			{
				nodeBaumBack[level]=(CellNode [,,] )nodeBaum[level].Clone();
			}

			Win32.HiPerfTimer timmer = new Win32.HiPerfTimer();
			timmer.Start();
			MoveDown(0, 0, 0, 0, ref changed);
			//Serialisation();
			timmer.Stop();
			Console.WriteLine("zeit: "+timmer.Duration);
			/*borderLenght = (int)System.Math.Pow(2,this.baumtiefe);
			neu = (runCounter%2+1)%2;
			for (int level=0; level<this.baumtiefe; level++)
			{
				for (int i=0; i< (int)System.Math.Pow(2,level); i++)
				{
					for (int j=0; j< (int)System.Math.Pow(2,level); j++)
					{
						for (int k=0; k< (int)System.Math.Pow(2,level); k++)
						{
							Console.WriteLine("level " + level+","+ i+","+j+","+k+": "+nodeBaumBack[level][i,j,k].changed);
							Console.WriteLine("level " + level+","+ i+","+j+","+k+": "+nodeBaum[level][i,j,k].changed);
							Console.WriteLine();
						}
					}
				}
				Console.WriteLine();
				//Console.ReadLine();
			}*/

			/*for (int i=0; i< borderLenght; i++)
			{
				for (int j=0; j< borderLenght; j++)
				{
					for (int k=0; k< borderLenght; k++)
					{
						Console.WriteLine("leafs "+i+","+j+","+k+": "+leafs[i,j,k].changed);
						Console.WriteLine("leafsBack "+ i+","+j+","+k+": "+leafsBack[i,j,k].changed);
						//Console.WriteLine("leafs "+i+","+j+","+k+": "+leafs[i,j,k].updRate);
						//Console.WriteLine("leafsBack "+ i+","+j+","+k+": "+leafsBack[i,j,k].updRate);
                     
						/*if(leafs [i,j,k].changed)
						{
							Console.WriteLine(i+","+j+","+k+": "+"Leaf geandert");
						}
					}
				}Console.ReadLine();
			}*/

			runCounter++;
			return changed;
		}

		public void MoveDown (int l, int x, int y, int z, ref bool changed)
		{
			//Console.WriteLine("LEVEL: "+l);
			int borderLenght = (int)System.Math.Pow(2, l);
			int borderLLeaf = (int)System.Math.Pow(2, baumtiefe);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			bool [,,] childs = new bool[2, 2, 2];
			ArrayList updRates = new ArrayList();

			current=runCounter%2;
			neu=(runCounter%2+1)%2;
			bool changedB = false;

			if(!nodeBaumBack[l][x, y, z].changed)
			{
				if(nodeBaumBack[l][(xo+neibFace1[0])%borderLenght, (yo+neibFace1[1])%borderLenght,
					(zo+neibFace1[2])%borderLenght].changed)
				{
					childs[1, 0, 0]=true;
					childs[1, 0, 1]=true;
					childs[1, 1, 0]=true;
					childs[1, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibFace2[0])%borderLenght, (yo+neibFace2[1])%borderLenght,
					(zo+neibFace2[2])%borderLenght].changed)
				{
					childs[0, 0, 0]=true;
					childs[0, 0, 1]=true;
					childs[0, 1, 0]=true;
					childs[0, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibFace3[0])%borderLenght, (yo+neibFace3[1])%borderLenght,
					(zo+neibFace3[2])%borderLenght].changed)
				{
					childs[0, 1, 0]=true;
					childs[0, 1, 1]=true;
					childs[1, 1, 0]=true;
					childs[1, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibFace4[0])%borderLenght, (yo+neibFace4[1])%borderLenght,
					(zo+neibFace4[2])%borderLenght].changed)
				{
					childs[0, 0, 0]=true;
					childs[0, 0, 1]=true;
					childs[1, 0, 0]=true;
					childs[1, 0, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibFace5[0])%borderLenght, (yo+neibFace5[1])%borderLenght,
					(zo+neibFace5[2])%borderLenght].changed)
				{
					childs[0, 0, 1]=true;
					childs[0, 1, 1]=true;
					childs[1, 0, 1]=true;
					childs[1, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibFace6[0])%borderLenght, (yo+neibFace6[1])%borderLenght,
					(zo+neibFace6[2])%borderLenght].changed)
				{
					childs[0, 0, 0]=true;
					childs[0, 1, 0]=true;
					childs[1, 0, 0]=true;
					childs[1, 1, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor1[0])%borderLenght, (yo+neibBor1[1])%borderLenght,
					(zo+neibBor1[2])%borderLenght].changed)
				{
					childs[0, 1, 0]=true;
					childs[0, 0, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor2[0])%borderLenght, (yo+neibBor2[1])%borderLenght,
					(zo+neibBor2[2])%borderLenght].changed)
				{
					childs[0, 0, 1]=true;
					childs[0, 0, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor3[0])%borderLenght, (yo+neibBor3[1])%borderLenght,
					(zo+neibBor3[2])%borderLenght].changed)
				{
					childs[0, 1, 1]=true;
					childs[0, 0, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor4[0])%borderLenght, (yo+neibBor4[1])%borderLenght,
					(zo+neibBor4[2])%borderLenght].changed)
				{
					childs[0, 1, 0]=true;
					childs[0, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor5[0])%borderLenght, (yo+neibBor5[1])%borderLenght,
					(zo+neibBor5[2])%borderLenght].changed)
				{
					childs[1, 0, 0]=true;
					childs[1, 0, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor6[0])%borderLenght, (yo+neibBor6[1])%borderLenght,
					(zo+neibBor6[2])%borderLenght].changed)
				{
					childs[1, 0, 1]=true;
					childs[1, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor7[0])%borderLenght, (yo+neibBor7[1])%borderLenght,
					(zo+neibBor7[2])%borderLenght].changed)
				{
					childs[1, 0, 0]=true;
					childs[1, 1, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor8[0])%borderLenght, (yo+neibBor8[1])%borderLenght,
					(zo+neibBor8[2])%borderLenght].changed)
				{
					childs[1, 1, 0]=true;
					childs[1, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor9[0])%borderLenght, (yo+neibBor9[1])%borderLenght,
					(zo+neibBor9[2])%borderLenght].changed)
				{
					childs[0, 1, 1]=true;
					childs[1, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor10[0])%borderLenght, (yo+neibBor10[1])%borderLenght,
					(zo+neibBor10[2])%borderLenght].changed)
				{
					childs[0, 1, 0]=true;
					childs[1, 1, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor11[0])%borderLenght, (yo+neibBor11[1])%borderLenght,
					(zo+neibBor11[2])%borderLenght].changed)
				{
					childs[0, 0, 1]=true;
					childs[1, 0, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibBor12[0])%borderLenght, (yo+neibBor12[1])%borderLenght,
					(zo+neibBor12[2])%borderLenght].changed)
				{
					childs[0, 0, 0]=true;
					childs[1, 0, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibCor1[0])%borderLenght, (yo+neibCor1[1])%borderLenght,
					(zo+neibCor1[2])%borderLenght].changed)
				{
					childs[0, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibCor2[0])%borderLenght, (yo+neibCor2[1])%borderLenght,
					(zo+neibCor2[2])%borderLenght].changed)
				{
					childs[0, 1, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibCor3[0])%borderLenght, (yo+neibCor3[1])%borderLenght,
					(zo+neibCor3[2])%borderLenght].changed)
				{
					childs[0, 0, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibCor4[0])%borderLenght, (yo+neibCor4[1])%borderLenght,
					(zo+neibCor4[2])%borderLenght].changed)
				{
					childs[0, 0, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibCor5[0])%borderLenght, (yo+neibCor5[1])%borderLenght,
					(zo+neibCor5[2])%borderLenght].changed)
				{
					childs[1, 1, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibCor6[0])%borderLenght, (yo+neibCor6[1])%borderLenght,
					(zo+neibCor6[2])%borderLenght].changed)
				{
					childs[1, 1, 0]=true;
				}

				if(nodeBaumBack[l][(xo+neibCor7[0])%borderLenght, (yo+neibCor7[1])%borderLenght,
					(zo+neibCor7[2])%borderLenght].changed)
				{
					childs[1, 0, 1]=true;
				}

				if(nodeBaumBack[l][(xo+neibCor8[0])%borderLenght, (yo+neibCor8[1])%borderLenght,
					(zo+neibCor8[2])%borderLenght].changed)
				{
					childs[1, 0, 0]=true;
				}
			}
			else
			{
				childs[0, 0, 0]=true;
				childs[0, 0, 1]=true;
				childs[0, 1, 0]=true;
				childs[0, 1, 1]=true;
				childs[1, 0, 0]=true;
				childs[1, 0, 1]=true;
				childs[1, 1, 0]=true;
				childs[1, 1, 1]=true;
			}

			if(l+1<baumtiefe)
			{
				if(childs[0, 0, 0])
				{
					changedB=false;
					MoveDown(l+1, 2*x, 2*y, 2*z, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 0, 1])
				{
					changedB=false;
					MoveDown(l+1, 2*x, 2*y, 2*z+1, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 1, 0])
				{
					changedB=false;
					MoveDown(l+1, 2*x, 2*y+1, 2*z, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 1, 1])
				{
					changedB=false;
					MoveDown(l+1, 2*x, 2*y+1, 2*z+1, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 0, 0])
				{
					changedB=false;
					MoveDown(l+1, 2*x+1, 2*y, 2*z, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 0, 1])
				{
					changedB=false;
					MoveDown(l+1, 2*x+1, 2*y, 2*z+1, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 1, 0])
				{
					changedB=false;
					MoveDown(l+1, 2*x+1, 2*y+1, 2*z, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 1, 1])
				{
					changedB=false;
					MoveDown(l+1, 2*x+1, 2*y+1, 2*z+1, ref changedB);
					changed=changed | changedB;
				}

				nodeBaum[l][x, y, z].changed=changed;
			}
			else
			{
				byte [,,] neigFieldBack = new byte[3, 3, 3];

				if(childs[0, 0, 0])
				{
					neighbourfield(2*x, 2*y, 2*z, ref neigFieldBack);
					changedB=false;
					Update(2*x, 2*y, 2*z, ref neigFieldBack, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 0, 1])
				{
					neighbourfield(2*x, 2*y, 2*z+1, ref neigFieldBack);
					changedB=false;
					Update(2*x, 2*y, 2*z+1, ref neigFieldBack, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 1, 0])
				{
					neighbourfield(2*x, 2*y+1, 2*z, ref neigFieldBack);
					changedB=false;
					Update(2*x, 2*y+1, 2*z, ref neigFieldBack, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 1, 1])
				{
					neighbourfield(2*x, 2*y+1, 2*z+1, ref neigFieldBack);
					changedB=false;
					Update(2*x, 2*y+1, 2*z+1, ref neigFieldBack, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 0, 0])
				{
					neighbourfield(2*x+1, 2*y, 2*z, ref neigFieldBack);
					changedB=false;
					Update(2*x+1, 2*y, 2*z, ref neigFieldBack, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 0, 1])
				{
					neighbourfield(2*x+1, 2*y, 2*z+1, ref neigFieldBack);
					changedB=false;
					Update(2*x+1, 2*y, 2*z+1, ref neigFieldBack, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 1, 0])
				{
					neighbourfield(2*x+1, 2*y+1, 2*z, ref neigFieldBack);
					changedB=false;
					Update(2*x+1, 2*y+1, 2*z, ref neigFieldBack, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 1, 1])
				{
					neighbourfield(2*x+1, 2*y+1, 2*z+1, ref neigFieldBack);
					changedB=false;
					Update(2*x+1, 2*y+1, 2*z+1, ref neigFieldBack, ref changedB);
					changed=changed | changedB;
				}

				nodeBaum[l][x, y, z].changed=changed;
			}
		}

		private void neighbourfield (int x, int y, int z, ref byte [,,] neigFieldBack)
		{
			int borderLLeaf = (int)System.Math.Pow(2, baumtiefe);
			int xo = x+borderLLeaf;
			int yo = y+borderLLeaf;
			int zo = z+borderLLeaf;

			for(int i = -1; i<2; i++)
			{
				for(int j = -1; j<2; j++)
				{
					for(int k = -1; k<2; k++)
					{
						neigFieldBack[i+1,
							j+1,
							k+1]=lstateBack[(xo+i)%borderLLeaf, (yo+j)%borderLLeaf,
							(zo+k)%borderLLeaf];
					}
				}
			}
			/*neigField[0,0,0].updRate = 56;
			Console.WriteLine(neigField[0,0,0].updRate +" "+neigFieldBack[0,0,0].updRate);
			Console.ReadLine();*/

		}

		private void Update (int x, int y, int z, ref byte[,,] neigFieldBack,
			ref bool changed)
		{
			/*
			int count = 0;

			for(int i = 0; i<3; i++)
				 for(int j = 0; j<3; j++)
					for(int k = 0; k<3; k++)
					{
						if(neigFieldBack[i, j, k]==1)
						{
							count++;
						}
					}

			if(count>0)
			{
				lstate[x,y,z]=1;
				if (neigFieldBack[1,1,1]==0)
				{
					changed=true;
				}
				else
				{
					changed=false;
				}
			}
			
			else
			{
				changed=false;
			}*/

			if (neigFieldBack[0,2,0]==0)
			{
				lstate[x,y,z]=0;
				if (neigFieldBack[1,1,1]==1)
				{
					changed=true;
				}
				else
				{
					
					changed=false;
				}
			}
			else
			{
				if (neigFieldBack[0,2,0]==1)
				{
					lstate[x,y,z]=1;;
					if (neigFieldBack[1,1,1]==0)
					{
						
						changed=true;
					}
					else
					{
						changed=false;
					}
				}
				else
				{
					changed=false;
				}

			}
		}
		private void Serialisation()
		{ 
			
			FileStream s = new FileStream("Frame" + runCounter + ".ser",FileMode.Create);
			IFormatter f = new BinaryFormatter();
			f.Serialize(s, lstate);
			s.Close();			
		}
	}
}
