using System;
using System.Collections;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace TableTree
{
	/// <summary>
	/// Zusammenfassung fr TableTree.
	/// </summary>
	/// 

	public abstract class TableTree
	{
		public uint runCounter = 0;
		public CellNode [] [,,] nodeBaum;
		public CellLeaf [,,] leafs;
		public CellNode [] [,,] nodeBaumBack;
		public CellLeaf [,,] leafsBack;
		public CellLeaf [,,] neigFieldBack = new CellLeaf[3,3,3];
		public int baumtiefe = 0;
		int borderLenght;

		private delegate void NeibConnectios (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs);
		private delegate void LeafNeibChange(ref bool chnaged);
		public enum Direction : byte
		{
			Left,
			Right,
			Top,
			Botton,
			Back,
			Front,
			BordLeftTop,
			BordLeftFront,
			BordLeftBotton,
			BordLeftBack,
			BordTopBack,
			BordTopFront,
			BordBottonFront,
			BordBottonBack,
			BordRightTop,
			BordRightFront,
			BordRightBotton,
			BordRightBack,
			CorLeftTopBack,
			CornLeftTopFront,
			CorLeftBottonFront,
			CorLeftBottonBack,
			CorRightTopBack,
			CroRightTopFront,
			CorRightBottonFront,
			CorRightBottonBack
		};
		private NeibConnectios conections;
		private LeafNeibChange testchanged;

		public byte RightNeibState
		{
			get{return neigFieldBack[0, 1, 1].state;}
		}

		public byte LeftNeibState
		{
			get{return neigFieldBack[2, 1, 1].state;}
		}

		public byte BottonNeibState
		{
			get
			{
				return neigFieldBack[1, 0, 1].state;
			}
		}

		public byte TopNeibState
		{
			get
			{
				return neigFieldBack[1, 2, 1].state;
			}
		}

		public byte FrontNeibState
		{
			get
			{
				return neigFieldBack[2, 1, 1].state;
			}
		}

		public byte BackNeibState
		{
			get
			{
				return neigFieldBack[1, 1, 2].state;
			}
		}

		public byte BordBottonFrontNeibState
		{
			get
			{
				return neigFieldBack[1, 0, 0].state;
			}
		}

		public byte BordBottonBackNeibState
		{
			get
			{
				return neigFieldBack[1, 0, 2].state;
			}
		}

		public byte BordTopFrontNeibState
		{
			get
			{
				return neigFieldBack[1, 2, 0].state;
			}
		}

		public byte BordTopBackNeibState
		{
			get
			{
				return neigFieldBack[1, 2, 2].state;
			}
		}

		public byte BordLeftFrontNeibState
		{
			get
			{
				return neigFieldBack[0, 1, 0].state;
			}
		}

		public byte BordLeftBackeNeibState
		{
			get
			{
				return neigFieldBack[0, 1, 2].state;
			}
		}

		public byte BordRightFrontNeibState
		{
			get
			{
				return neigFieldBack[2, 1, 0].state;
			}
		}

		public byte BordRightBackNeibState
		{
			get
			{
				return neigFieldBack[2, 1, 2].state;
			}
		}

		public byte BordLeftBottonNeibState
		{
			get
			{
				return neigFieldBack[0, 0, 1].state;
			}
		}

		public byte BordLeftTopNeibState
		{
			get
			{
				return neigFieldBack[0, 2, 1].state;
			}
		}

		public byte BordRightBottonNeibState
		{
			get
			{
				return neigFieldBack[2, 0, 1].state;
			}
		}

		public byte BordRightTopNeibState
		{
			get
			{
				return neigFieldBack[2, 2, 1].state;
			}
		}

		public byte CornLeftBottonFrontNeibState
		{
			get
			{
				return neigFieldBack[0, 0, 2].state;
			}
		}

		public byte CornLeftBottonBackNeibState
		{
			get
			{
				return neigFieldBack[0, 0, 2].state;
			}
		}

		public byte CornLeftTopFrontNeibState
		{
			get
			{
				return neigFieldBack[0, 2, 0].state;
			}
		}

		public byte CornLeftTopBackNeibState
		{
			get
			{
				return neigFieldBack[0, 2, 2].state;
			}
		}

		public byte CornRightBottonBackNeibState
		{
			get
			{
				return neigFieldBack[2, 0, 0].state;
			}
		}

		public byte CornRightBottonFrontNeibState
		{
			get
			{
				return neigFieldBack[2, 0, 2].state;
			}
		}

		public byte CornRightTopBackNeibState
		{
			get
			{
				return neigFieldBack[2, 2, 0].state;
			}
		}

		public byte CornRightTopFrontNeibState
		{
			get
			{
				return neigFieldBack[2, 2, 2].state;
			}
		}


		public TableTree (int baumtiefe)
		{
			this.baumtiefe=baumtiefe;
			nodeBaum=new CellNode[baumtiefe][,,];
			SetNeibConnections(GiveUsedNeibDirection());
			for(int level = 0; level<this.baumtiefe; level++)
			{
				borderLenght=(int)System.Math.Pow(2, level);
				nodeBaum[level]=new CellNode[borderLenght, borderLenght, borderLenght];

				for(int i = 0; i<borderLenght; i++)
				{
					for(int j = 0; j<borderLenght; j++)
					{
						for(int k = 0; k<borderLenght; k++)
						{
							nodeBaum[level][i, j, k].changed=true;
						}
					}
				}
			}

			borderLenght=(int)System.Math.Pow(2, this.baumtiefe);
			leafs=new CellLeaf[borderLenght, borderLenght, borderLenght];

			for(int i = 0; i<borderLenght; i++)
			{
				for(int j = 0; j<borderLenght; j++)
				{
					for(int k = 0; k<borderLenght; k++)
					{
						leafs[i, j, k].changed=false;
						leafs[i, j, k].state=0;
					}
				}
			}
		}

		public bool CycleStart ()
		{
			bool changed = false;

			leafsBack=(CellLeaf [,,] )leafs.Clone();
			nodeBaumBack=new CellNode[baumtiefe][,,];
			
			for(int level = 0; level<this.baumtiefe; level++)
			{
				nodeBaumBack[level]=(CellNode [,,] )nodeBaum[level].Clone();
			}

			Win32.HiPerfTimer timmer = new Win32.HiPerfTimer();
			timmer.Start();
			MoveDown(0, 0, 0, 0, ref changed);
			//Serialisation();
			timmer.Stop();
			Console.WriteLine("zeit: "+timmer.Duration);
			/*borderLenght = (int)System.Math.Pow(2,this.baumtiefe);
			neu = (runCounter%2+1)%2;
			for (int level=0; level<this.baumtiefe; level++)
			{
				for (int i=0; i< (int)System.Math.Pow(2,level); i++)
				{
					for (int j=0; j< (int)System.Math.Pow(2,level); j++)
					{
						for (int k=0; k< (int)System.Math.Pow(2,level); k++)
						{
							Console.WriteLine("level " + level+","+ i+","+j+","+k+": "+nodeBaumBack[level][i,j,k].changed);
							Console.WriteLine("level " + level+","+ i+","+j+","+k+": "+nodeBaum[level][i,j,k].changed);
							Console.WriteLine();
						}
					}
				}
				Console.WriteLine();
				//Console.ReadLine();
			}*/

			/*for (int i=0; i< borderLenght; i++)
			{
				for (int j=0; j< borderLenght; j++)
				{
					for (int k=0; k< borderLenght; k++)
					{
						if(leafs[i,j,k].state==1)
						Console.WriteLine("leafs "+i+","+j+","+k+": "+leafs[i,j,k].state);
						//Console.WriteLine("leafsBack "+ i+","+j+","+k+": "+leafsBack[i,j,k].changed);
						//Console.WriteLine("leafs "+i+","+j+","+k+": "+leafs[i,j,k].updRate);
						//Console.WriteLine("leafsBack "+ i+","+j+","+k+": "+leafsBack[i,j,k].updRate);
                     
						/*if(leafs [i,j,k].changed)
						{
							Console.WriteLine(i+","+j+","+k+": "+"Leaf geandert");
						}
					}
				}//Console.ReadLine();
			}*/

			runCounter++;
			return changed;
		}
		private void SetNeibConnections (byte []directions)
		{
			foreach(byte direction in directions)
			{
				if(direction==0)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged0);
					conections+=new NeibConnectios(CheckNeiBLeft);
				}

				if(direction==1)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged1);
					conections+=new NeibConnectios(CheckNeiBRight);
				}

				if(direction==2)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged2);
					conections+=new NeibConnectios(CheckNeiBTop);
				}

				if(direction==3)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged3);
					conections+=new NeibConnectios(CheckNeiBBotton);
				}

				if(direction==4)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged4);
					conections+=new NeibConnectios(CheckNeiBBack);
				}

				if(direction==5)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged5);
					conections+=new NeibConnectios(CheckNeiBFront);
				}

				if(direction==6)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged6);
					conections+=new NeibConnectios(CheckNeiBBordLeftTop);
				}

				if(direction==7)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged7);
					conections+=new NeibConnectios(CheckNeiBBordLeftFront);
				}

				if(direction==8)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged8);
					conections+=new NeibConnectios(CheckNeiBBordLeftBotton);
				}

				if(direction==9)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged9);
					conections+=new NeibConnectios(CheckNeiBBordLeftBack);
				}

				if(direction==10)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged10);
					conections+=new NeibConnectios(CheckNeiBBordTopBack);
				}

				if(direction==11)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged11);
					conections+=new NeibConnectios(CheckNeiBBordTopFront);
				}

				if(direction==12)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged12);
					conections+=new NeibConnectios(CheckNeiBBordBottonFront);
				}

				if(direction==13)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged13);
					conections+=new NeibConnectios(CheckNeiBBordBottonBack);
				}

				if(direction==14)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged14);
					conections+=new NeibConnectios(CheckNeiBBordRightTop);
				}

				if(direction==15)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged15);
					conections+=new NeibConnectios(CheckNeiBBordRightFront);
				}

				if(direction==16)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged16);
					conections+=new NeibConnectios(CheckNeiBBordRightBotton);
				}

				if(direction==17)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged17);
					conections+=new NeibConnectios(CheckNeiBBordRightBack);
				}

				if(direction==18)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged18);
					conections+=new NeibConnectios(CheckNeiBCorLeftTopBack);
				}

				if(direction==19)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged19);
					conections+=new NeibConnectios(CheckNeiBCornLeftTopFront);
				}

				if(direction==20)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged20);
					conections+=new NeibConnectios(CheckNeiBCorLeftBottonFront);
				}

				if(direction==21)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged21);
					conections+=new NeibConnectios(CheckNeiBCorLeftBottonBack);
				}

				if(direction==22)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged22);
					conections+=new NeibConnectios(CheckNeiBCorRightTopBack);
				}

				if(direction==23)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged23);
					conections+=new NeibConnectios(CheckNeiBCroRightTopFront);
				}

				if(direction==24)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged24);
					conections+=new NeibConnectios(CheckNeiBCorRightBottonFront);
				}

				if(direction==25)
				{
					testchanged+= new LeafNeibChange(IsNeibLeafChanged25);
					conections+=new NeibConnectios(CheckNeiBCorRightBottonBack);
				}
			}
		}

		public void MoveDown (int l, int x, int y, int z, ref bool changed)
		{
			//Console.WriteLine("LEVEL: "+l);
			int borderLenght = (int)System.Math.Pow(2, l);
			int borderLLeaf = (int)System.Math.Pow(2, baumtiefe);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			bool [,,] childs = new bool[2, 2, 2];

			bool changedB = false;

			if(!nodeBaumBack[l][x, y, z].changed)
			{
				conections(xo, yo, zo, borderLenght, l, childs);
			}
			else
			{
				childs[0, 0, 0]=true;
				childs[0, 0, 1]=true;
				childs[0, 1, 0]=true;
				childs[0, 1, 1]=true;
				childs[1, 0, 0]=true;
				childs[1, 0, 1]=true;
				childs[1, 1, 0]=true;
				childs[1, 1, 1]=true;
			}

			if(l+1<baumtiefe)
			{
				if(childs[0, 0, 0])
				{
					changedB=false;
					MoveDown(l+1, 2*x, 2*y, 2*z, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 0, 1])
				{
					changedB=false;
					MoveDown(l+1, 2*x, 2*y, 2*z+1, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 1, 0])
				{
					changedB=false;
					MoveDown(l+1, 2*x, 2*y+1, 2*z, ref changedB);
					changed=changed | changedB;
				}

				if(childs[0, 1, 1])
				{
					changedB=false;
					MoveDown(l+1, 2*x, 2*y+1, 2*z+1, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 0, 0])
				{
					changedB=false;
					MoveDown(l+1, 2*x+1, 2*y, 2*z, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 0, 1])
				{
					changedB=false;
					MoveDown(l+1, 2*x+1, 2*y, 2*z+1, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 1, 0])
				{
					changedB=false;
					MoveDown(l+1, 2*x+1, 2*y+1, 2*z, ref changedB);
					changed=changed | changedB;
				}

				if(childs[1, 1, 1])
				{
					changedB=false;
					MoveDown(l+1, 2*x+1, 2*y+1, 2*z+1, ref changedB);
					changed=changed | changedB;
				}

				nodeBaum[l][x, y, z].changed=changed;
			}
			else
			{

				if(childs[0, 0, 0])
				{
					neighbourfield(2*x, 2*y, 2*z);
					changedB=false;
					UpdateState(ref changedB,2*x, 2*y, 2*z);
					changed=changed | changedB;
				}

				if(childs[0, 0, 1])
				{
					neighbourfield(2*x, 2*y, 2*z+1);
					changedB=false;
					UpdateState(ref changedB,2*x, 2*y, 2*z+1);
					changed=changed | changedB;
				}

				if(childs[0, 1, 0])
				{
					neighbourfield(2*x, 2*y+1, 2*z);
					changedB=false;
					UpdateState(ref changedB,2*x, 2*y+1, 2*z);
					changed=changed | changedB;
				}

				if(childs[0, 1, 1])
				{
					neighbourfield(2*x, 2*y+1, 2*z+1);
					changedB=false;
					UpdateState(ref changedB,2*x, 2*y+1, 2*z+1);
					changed=changed | changedB;
				}

				if(childs[1, 0, 0])
				{
					neighbourfield(2*x+1, 2*y, 2*z);
					changedB=false;
					UpdateState(ref changedB,2*x+1, 2*y, 2*z);
					changed=changed | changedB;
				}

				if(childs[1, 0, 1])
				{
					neighbourfield(2*x+1, 2*y, 2*z+1);
					changedB=false;
					UpdateState(ref changedB,2*x+1, 2*y, 2*z+1);
					changed=changed | changedB;
				}

				if(childs[1, 1, 0])
				{
					neighbourfield(2*x+1, 2*y+1, 2*z);
					changedB=false;
					UpdateState(ref changedB,2*x+1, 2*y+1, 2*z);
					changed=changed | changedB;
				}

				if(childs[1, 1, 1])
				{
					neighbourfield(2*x+1, 2*y+1, 2*z+1);
					changedB=false;
					UpdateState(ref changedB,2*x+1, 2*y+1, 2*z+1);
					changed=changed | changedB;
				}

				nodeBaum[l][x, y, z].changed=changed;
			}
		}
		
		private void CheckNeiBRight (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed)
			{
				childs[1, 0, 0]=true;
				childs[1, 0, 1]=true;
				childs[1, 1, 0]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged0(ref bool changed)
		{
			changed = changed | neigFieldBack[2,1,1].changed;
		}

		private void CheckNeiBLeft (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed)
			{
				childs[0, 0, 0]=true;
				childs[0, 0, 1]=true;
				childs[0, 1, 0]=true;
				childs[0, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged1(ref bool changed)
		 {
			 changed = changed | neigFieldBack[0,1,1].changed;
		 }

		private void CheckNeiBTop (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo)%borderLenght, (yo+1)%borderLenght,(zo)%borderLenght].changed)
			{
				childs[0, 1, 0]=true;
				childs[0, 1, 1]=true;
				childs[1, 1, 0]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged2(ref bool changed)
		{
			changed = changed | neigFieldBack[1,2,1].changed;
		}
		private void CheckNeiBBotton (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][(xo)%borderLenght, (yo-1)%borderLenght,(zo)%borderLenght].changed)
			{
				childs[0, 0, 0]=true;
				childs[0, 0, 1]=true;
				childs[1, 0, 0]=true;
				childs[1, 0, 1]=true;
			}
		}
		private void IsNeibLeafChanged3(ref bool changed)
		{
			changed = changed | neigFieldBack[1,0,1].changed;
		}
		private void CheckNeiBBack (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[0, 0, 1]=true;
				childs[0, 1, 1]=true;
				childs[1, 0, 1]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged4(ref bool changed)
		{
			changed = changed | neigFieldBack[1,1,2].changed;
		}
		private void CheckNeiBFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[0, 0, 0]=true;
				childs[0, 1, 0]=true;
				childs[1, 0, 0]=true;
				childs[1, 1, 0]=true;
			}
		}
		private void IsNeibLeafChanged5(ref bool changed)
		{
			changed = changed | neigFieldBack[1,1,0].changed;
		}
		private void CheckNeiBBordLeftFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[0, 1, 0]=true;
				childs[0, 0, 0]=true;
			}
		}
		private void IsNeibLeafChanged6(ref bool changed)
		{
			changed = changed | neigFieldBack[0,1,0].changed;
		}
		private void CheckNeiBBordLeftBotton (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo-1)%borderLenght,(zo)%borderLenght].changed)
			{
				childs[0, 0, 1]=true;
				childs[0, 0, 0]=true;
			}
		}
		private void IsNeibLeafChanged7(ref bool changed)
		{
			changed = changed | neigFieldBack[0,0,1].changed;
		}
		private void CheckNeiBBordLeftBack (int xo, int yo, int zo ,int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[0, 1, 1]=true;
				childs[0, 0, 1]=true;
			}
		}
		private void IsNeibLeafChanged8(ref bool changed)
		{
			changed = changed | neigFieldBack[0,1,2].changed;
		}
		private void CheckNeiBBordLeftTop (int xo, int yo, int zo ,int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo+1)%borderLenght,(zo)%borderLenght].changed)
			{
				childs[0, 1, 0]=true;
				childs[0, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged9(ref bool changed)
		{
			changed = changed | neigFieldBack[0,2,1].changed;
		}
		private void CheckNeiBBordRightBotton (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo-1)%borderLenght,(zo)%borderLenght].changed)
			{
				childs[1, 0, 0]=true;
				childs[1, 0, 1]=true;
			}
		}
		private void IsNeibLeafChanged10(ref bool changed)
		{
			changed = changed | neigFieldBack[2,1,0].changed;
		}
		private void CheckNeiBBordRightBack (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[1, 0, 1]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged11(ref bool changed)
		{
			changed = changed | neigFieldBack[2,0,2].changed;
		}
		private void CheckNeiBBordRightFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[1, 0, 0]=true;
				childs[1, 1, 0]=true;
			}
		}
		private void IsNeibLeafChanged12(ref bool changed)
		{
			changed = changed | neigFieldBack[2,0,1].changed;
		}
		private void CheckNeiBBordRightTop (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo+1)%borderLenght,(zo)%borderLenght].changed)
			{
				childs[1, 1, 0]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged13(ref bool changed)
		{
			changed = changed | neigFieldBack[2,2,1].changed;
		}
		private void CheckNeiBBordTopBack (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo)%borderLenght, (yo+1)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[0, 1, 1]=true;
				childs[1, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged14(ref bool changed)
		{
			changed = changed | neigFieldBack[1,2,2].changed;
		}
		private void CheckNeiBBordTopFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo)%borderLenght, (yo+1)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[0, 1, 0]=true;
				childs[1, 1, 0]=true;
			}
		}
		private void IsNeibLeafChanged15(ref bool changed)
		{
			changed = changed | neigFieldBack[1,2,0].changed;
		}
		private void CheckNeiBBordBottonBack (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo)%borderLenght, (yo-1)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[0, 0, 1]=true;
				childs[1, 0, 1]=true;
			}
		}
		private void IsNeibLeafChanged16(ref bool changed)
		{
			changed = changed | neigFieldBack[1,0,2].changed;
		}
		private void CheckNeiBBordBottonFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo)%borderLenght, (yo-1)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[0, 0, 0]=true;
				childs[1, 0, 0]=true;
			}
		}
		private void IsNeibLeafChanged17(ref bool changed)
		{
			changed = changed | neigFieldBack[1,0,0].changed;
		}
		private void CheckNeiBCorLeftTopBack (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo+1)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[0, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged18(ref bool changed)
		{
			changed = changed | neigFieldBack[0,2,2].changed;
		}
		private void CheckNeiBCornLeftTopFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo+1)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[0, 1, 0]=true;
			}
		}
		private void IsNeibLeafChanged19(ref bool changed)
		{
			changed = changed | neigFieldBack[0,2,0].changed;
		}
		private void CheckNeiBCorLeftBottonBack (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo-1)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[0, 0, 1]=true;
			}
		}
		private void IsNeibLeafChanged20(ref bool changed)
		{
			changed = changed | neigFieldBack[0,0,2].changed;
		}
		private void CheckNeiBCorLeftBottonFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo-1)%borderLenght, (yo-1)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[0, 0, 0]=true;
			}
		}
		private void IsNeibLeafChanged21(ref bool changed)
		{
			changed = changed | neigFieldBack[0,0,0].changed;
		}
		private void CheckNeiBCorRightTopBack (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo+1)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[1, 1, 1]=true;
			}
		}
		private void IsNeibLeafChanged22(ref bool changed)
		{
			changed = changed | neigFieldBack[2,2,2].changed;
		}
		private void CheckNeiBCroRightTopFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo+1)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[1, 1, 0]=true;
			}
		}
		private void IsNeibLeafChanged23(ref bool changed)
		{
			changed = changed | neigFieldBack[2,2,0].changed;
		}
		private void CheckNeiBCorRightBottonBack (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo-1)%borderLenght,(zo+1)%borderLenght].changed)
			{
				childs[1, 0, 1]=true;
			}
		}
		private void IsNeibLeafChanged24(ref bool changed)
		{
			changed = changed | neigFieldBack[2,0,2].changed;
		}
		private void CheckNeiBCorRightBottonFront (int xo, int yo, int zo, int borderLenght, int l, bool [,,] childs)
		{
			if(nodeBaumBack[l][ (xo+1)%borderLenght, (yo-1)%borderLenght,(zo-1)%borderLenght].changed)
			{
				childs[1, 0, 0]=true;
			}
		}
		private void IsNeibLeafChanged25(ref bool changed)
		{
			changed = changed | neigFieldBack[2,0,0].changed;
		}


		private void neighbourfield (int x, int y, int z)
		{
			int borderLLeaf = (int)System.Math.Pow(2, baumtiefe);
			int xo = x+borderLLeaf;
			int yo = y+borderLLeaf;
			int zo = z+borderLLeaf;

			for(int i = -1; i<2; i++)
			{
				for(int j = -1; j<2; j++)
				{
					for(int k = -1; k<2; k++)
					{
						this.neigFieldBack[i+1,j+1,k+1]=leafsBack[(xo+i)%borderLLeaf, (yo+j)%borderLLeaf,
							(zo+k)%borderLLeaf];

					}
				}
			}
			

		}

		private void UpdateState (ref bool changed,int x,int y, int z)
		{
            bool changedNeib=false;
			if(!neigFieldBack[1, 1, 1].changed)
			{
				testchanged(ref changedNeib);
				if(changedNeib)
				{
					SetState(Rules(neigFieldBack[1, 1, 1].state), ref changed,x,y,z);
				}
			}
			else
			{
				SetState(Rules(neigFieldBack[1, 1, 1].state), ref changed,x,y,z);
			}
		}

		public int CountNeibWhiteState( byte state)
		{ 
			int count = 0;
			for(int i = 0; i<3; i++)
				for(int j = 0; j<3; j++)
					for(int k = 0; k<3; k++)
					{
						if(neigFieldBack[i, j, k].state== state)
						{
							count++;
						}
					}
			return count;
		}

		private void SetState (byte state,ref bool changed,int x, int y, int z)
		{
			leafs[x,y,z].state=(byte)state;

			if(neigFieldBack[1, 1, 1].state!=state)
			{
				changed=true;
				leafs[x,y,z].changed=true;
			}
			else
			{
				changed=false;
				leafs[x,y,z].changed=false;
			}

		}

		
		private void Serialisation()
		{ 
			byte[,,] array = new byte[borderLenght,borderLenght,borderLenght];
			for(int i = 0; i<borderLenght; i++)
			{
				for(int j = 0; j<borderLenght; j++)
				{
					for(int k = 0; k<borderLenght; k++)
					{
						array[i,j,k] = leafs[i, j, k].state;
					}
				}
			}
			FileStream s = new FileStream("Frame" + runCounter + ".ser",FileMode.Create);
			IFormatter f = new BinaryFormatter();
			f.Serialize(s, array);
			s.Close();			
		}
		abstract public byte Rules (byte currentstate);
		abstract public byte[] GiveUsedNeibDirection();
	}
}
