using System;
using System.Collections;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace TableTree
{
	/// <summary>
	/// Zusammenfassung fr TableTree.
	/// </summary>
	/// 

	public abstract class TableTree
	{
		public uint runCounter = 0;
		protected int baumtiefe = 0;
		private int borderLenght;
		private int borderLeafLenght;
		
		private CellNode [] [,,] nodeBaum;
		protected byte[,,] lstate;
		private CellNode [] [,,] nodeBaumBack;
		private byte[,,] lstateBack;
		private byte [,,] neigFieldBack = new byte[3,3,3];
		
		private delegate bool childToCalcFuncType (int xo, int yo, int zo, int l);
		private childToCalcFuncType [,,] childToCalcFunc= new childToCalcFuncType[2,2,2];
		
		public enum Direction : byte
		{
			Left,
			Right,
			Top,
			Botton,
			Back,
			Front,
			BordLeftTop,
			BordLeftFront,
			BordLeftBotton,
			BordLeftBack,
			BordTopBack,
			BordTopFront,
			BordBottonFront,
			BordBottonBack,
			BordRightTop,
			BordRightFront,
			BordRightBotton,
			BordRightBack,
			CorLeftTopBack,
			CornLeftTopFront,
			CorLeftBottonFront,
			CorLeftBottonBack,
			CorRightTopBack,
			CroRightTopFront,
			CorRightBottonFront,
			CorRightBottonBack
		};
		
		const byte BMaskChildAll=255;
		const byte BMaskChildLowLeftFront=1;
		const byte BMaskChildLowLeftBack=2;
		const byte BMaskChildLowRightFront=4;
		const byte BMaskChildLowRightBack=8;
		const byte BMaskChildUpLeftFront=16;
		const byte BMaskChildUpLeftBack=32;
		const byte BMaskChildUpRightFront=64;
		const byte BMaskChildUpRightBack=128;
		
		const byte BMaskChildRightHalf=204;
		const byte BMaskChildLeftHalf=51;
		const byte BMaskChildUpHalf=240;
		const byte BMaskChildLowHalf=15;
		const byte BMaskChildFrontHalf=85;
		const byte BMaskChildBackHalf=170;
		
		const byte BMaskChildLowLeftEdge=3;
		const byte BMaskChildLowRightEdge=12;
		const byte BMaskChildUpRightEdge=192;
		const byte BMaskChildUpLeftEdge=48;
		const byte BMaskChildLowFrontEdge=5;
		const byte BMaskChildLowBackEdge=10;
		const byte BMaskChildUpFrontEdge=80;
		const byte BMaskChildUpBackEdge=160;
		const byte BMaskChildFrontLeftEdge=17;
		const byte BMaskChildFrontRightEdge=68;
		const byte BMaskChildBackLeftEdge=34;
		const byte BMaskChildBackRightEdge=136;
		byte[,,]BMaskChildField = {
										{
											{BMaskChildLowLeftFront, BMaskChildLowLeftBack},
											{BMaskChildUpLeftFront, BMaskChildUpLeftBack}
										},
										{
											{BMaskChildLowRightFront, BMaskChildLowRightBack},
											{BMaskChildUpRightFront, BMaskChildUpRightBack}
										}
									  };

		


		public TableTree (int baumtiefe)
		{
			this.baumtiefe=baumtiefe;
			nodeBaum=new CellNode[baumtiefe][,,];
			SetChildToCalcFunc(GiveUsedNeibDirection());
			for(int level = 0; level<this.baumtiefe; level++)
			{
				borderLenght=(int)System.Math.Pow(2, level);
				nodeBaum[level]=new CellNode[borderLenght, borderLenght, borderLenght];

				for(int i = 0; i<borderLenght; i++)
				{
					for(int j = 0; j<borderLenght; j++)
					{
						for(int k = 0; k<borderLenght; k++)
						{
							nodeBaum[level][i, j, k].changed=BMaskChildAll;
						}
					}
				}
			}

			borderLeafLenght=(int)System.Math.Pow(2, this.baumtiefe);
			lstate=new byte[borderLeafLenght, borderLeafLenght, borderLeafLenght];

			/*for(int i = 0; i<borderLeafLenght; i++)
			{
				for(int j = 0; j<borderLeafLenght; j++)
				{
					for(int k = 0; k<borderLeafLenght; k++)
					{
						lstate[i, j, k]=0;
					}
				}
			}*/
		}
		
		private void SetChildToCalcFunc (byte []directions)
		{
			  childToCalcFunc[0,0,0]+=new childToCalcFuncType(CheckLowLeftFrontChildTypeFaceOnly);
				childToCalcFunc[1,0,0]+=new childToCalcFuncType(CheckLowRightFrontChildTypeFaceOnly);
				childToCalcFunc[1,1,0]+=new childToCalcFuncType(CheckUpRightFrontChildTypeFaceOnly);
				childToCalcFunc[0,1,0]+=new childToCalcFuncType(CheckUpLeftFrontChildTypeFaceOnly);
				childToCalcFunc[1,0,1]+=new childToCalcFuncType(CheckLowRightBackChildTypeFaceOnly);
				childToCalcFunc[0,0,1]+=new childToCalcFuncType(CheckLowLeftBackChildTypeFaceOnly);
				childToCalcFunc[1,1,1]+=new childToCalcFuncType(CheckUpRightBackChildTypeFaceOnly);
				childToCalcFunc[0,1,1]+=new childToCalcFuncType(CheckUpLeftBackChildTypeFaceOnly);
		}

				
		public byte CycleStart ()
		{
			byte changed = 0;
			lstateBack=(byte [,,] )lstate.Clone();
			nodeBaumBack=new CellNode[baumtiefe][,,];
			//Serialisation();
			for(int level = 0; level<this.baumtiefe; level++)
			{
				nodeBaumBack[level]=(CellNode [,,] )nodeBaum[level].Clone();
			}

			Win32.HiPerfTimer timmer = new Win32.HiPerfTimer();
			timmer.Start();
			MoveDown(0, 0, 0, 0, ref changed);
			//Serialisation();
			timmer.Stop();
			Console.WriteLine("zeit: "+timmer.Duration);
			/*
			borderLenght = (int)System.Math.Pow(2,this.baumtiefe);
			for (int level=0; level<this.baumtiefe; level++)
			{
				for (int i=0; i< (int)System.Math.Pow(2,level); i++)
				{
					for (int j=0; j< (int)System.Math.Pow(2,level); j++)
					{
						for (int k=0; k< (int)System.Math.Pow(2,level); k++)
						{
							if(nodeBaum[level][i,j,k].changed)
							{
								//Console.WriteLine("level " + level+","+ i+","+j+","+k+": "+nodeBaumBack[level][i,j,k].changed);
								Console.WriteLine("level " + level+","+ i+","+j+","+k+": "+nodeBaum[level][i,j,k].changed);
								//Console.WriteLine();
							}
						}
					}
				}
				Console.WriteLine();
				Console.ReadLine();
			}*/
			/*
			for (int i=0; i< borderLenght; i++)
			{
				for (int j=0; j< borderLenght; j++)
				{
					for (int k=0; k< borderLenght; k++)
					{
						
						//Console.WriteLine("leafs "+i+","+j+","+k+": "+leafs[i,j,k].changed);
						//Console.WriteLine("leafsBack "+ i+","+j+","+k+": "+leafsBack[i,j,k].changed);
						Console.WriteLine("leafs "+i+","+j+","+k+": "+lstate[i,j,k]);
						//Console.WriteLine("leafsBack "+ i+","+j+","+k+": "+leafsBack[i,j,k].updRate);
                     
					}
				}Console.ReadLine();
			}*/

			runCounter++;
			return changed;
		}

		private void MoveDown (int l, int x, int y, int z, ref byte changed)
		{ 
		//Console.WriteLine("LEVEL: "+l); 
		
		byte changedB = 0;
		bool changedBB=false;
							
			if(l+1<baumtiefe)
			{
				for(int i = 0; i<2; i++)
				{
					for(int j = 0; j<2; j++)
					{
						for(int k = 0; k<2; k++)
						{
							changedB=0;
							if(childToCalcFunc[i,j,k](x,y,z,l))
							{
							   MoveDown(l+1, 2*x+i, 2*y+j, 2*z+k, ref changedB);
						  }
							if(changedB!=0)
							changed=(byte)(changed | BMaskChildField[i,j,k]); 
						}
					}
				}
				nodeBaum[l][x, y, z].changed=changed;
			}
			else/*l=Baumtiefe-1*/
			{
				for(int i = 0; i<2; i++)
				{
					for(int j = 0; j<2; j++)
					{
						for(int k = 0; k<2; k++)
						{
							changedBB=false;
							neighbourfield(2*x+i, 2*y+j, 2*z+k);
							if(childToCalcFunc[i,j,k](x,y,z,l))
							{
							   UpdateState(ref changedBB,2*x+i, 2*y+j, 2*z+k);;
							}
							if(changedBB)
							changed=(byte)(changed | BMaskChildField[i,j,k]); 
						}
					}
				}
				nodeBaum[l][x, y, z].changed=changed;
			}
		}
		
		private void neighbourfield (int x, int y, int z)
		{
			int xo = x+borderLeafLenght;
			int yo = y+borderLeafLenght;
			int zo = z+borderLeafLenght;

			for(int i = -1; i<2; i++)
			{
				for(int j = -1; j<2; j++)
				{
					for(int k = -1; k<2; k++)
					{
						this.neigFieldBack[i+1,j+1,k+1]=lstateBack[(xo+i)%borderLeafLenght, (yo+j)%borderLeafLenght,(zo+k)%borderLeafLenght]; 
					}
				}
			}
		}

		private void UpdateState (ref bool changed,int x,int y, int z)
		{
			byte state=Rules(neigFieldBack[1, 1, 1]);
			lstate[x,y,z]=(byte)state;

			if(neigFieldBack[1, 1, 1]!=state)
			{
				changed=true;
			}
			else
			{
				changed=false;
			}
		}

		protected int CountNeibWhiteState( byte state)
		{ 
			int count = 0;
			for(int i = 0; i<3; i++)
				for(int j = 0; j<3; j++)
					for(int k = 0; k<3; k++)
					{
						if(neigFieldBack[i, j, k]== state)
						{
							count++;
						}
					}
			return count;
		}
		
			
		
		private bool CheckUpRightBackChildTypeFaceOnly (int x, int y, int z, int l)
		{
			borderLenght=(int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			return ( (nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildUpRightBack)!=0/*self first!*/
			        |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildUpLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightBack)!=0
		          |(nodeBaumBack[l][ (xo+1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo+1)%borderLenght].changed
		            &BMaskChildUpRightFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo+1)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightBack)!=0);      
		          
		}
		
		private bool CheckUpRightFrontChildTypeFaceOnly (int x, int y, int z, int l)
		{
			borderLenght=(int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			return ( (nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildUpRightFront)!=0/*self first!*/
			        |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildUpLeftFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightFront)!=0
		          |(nodeBaumBack[l][ (xo+1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpLeftFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo-1)%borderLenght].changed
		            &BMaskChildUpRightBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo+1)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightFront)!=0);      
		          
		}
		
		private bool CheckUpLeftBackChildTypeFaceOnly (int x, int y, int z, int l)
		{
			borderLenght=(int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			return ( (nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildUpLeftBack)!=0/*self first!*/
			        |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpLeftFront)!=0
		          |(nodeBaumBack[l][ (xo-1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo+1)%borderLenght].changed
		            &BMaskChildUpLeftFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo+1)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowLeftBack)!=0);      
		          
		}
		
		private bool CheckUpLeftFrontChildTypeFaceOnly (int x, int y, int z, int l)
		{
			borderLenght=(int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			return ( (nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildUpLeftFront)!=0/*self first!*/
			        |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildUpLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowLeftFront)!=0
		          |(nodeBaumBack[l][ (xo-1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo-1)%borderLenght].changed
		            &BMaskChildUpLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo+1)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowLeftFront) !=0);     
		          
		}
		
		private bool CheckLowRightBackChildTypeFaceOnly (int x, int y, int z, int l)
		{
			borderLenght=(int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			return ( (nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowRightBack)!=0/*self first!*/
			        |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightBack)!=0
		          |(nodeBaumBack[l][ (xo+1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo+1)%borderLenght].changed
		            &BMaskChildLowRightFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo-1)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightBack)!=0);      
		          
		}
		
		private bool CheckLowRightFrontChildTypeFaceOnly (int x, int y, int z, int l)
		{
			borderLenght=(int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			return ( (nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowRightFront)!=0/*self first!*/
			        |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowLeftFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightFront)!=0
		          |(nodeBaumBack[l][ (xo+1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowLeftFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo-1)%borderLenght].changed
		            &BMaskChildLowRightBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo-1)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpRightFront) !=0 );    
		          
		}

		private bool CheckLowLeftFrontChildTypeFaceOnly (int x, int y, int z, int l)
		{
			borderLenght=(int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			return ( (nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowLeftFront)!=0/*self first!*/
			        |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpLeftFront)!=0
		          |(nodeBaumBack[l][ (xo-1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo-1)%borderLenght].changed
		            &BMaskChildLowLeftBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo-1)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpLeftFront)!=0 );     
		          
		}
		private bool CheckLowLeftBackChildTypeFaceOnly (int x, int y, int z, int l)
		{
			borderLenght=(int)System.Math.Pow(2, l);
			int xo = x+borderLenght;
			int yo = y+borderLenght;
			int zo = z+borderLenght;
			return ( (nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowLeftBack)!=0/*self first!*/
			        |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
			          &BMaskChildLowLeftFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpLeftBack)!=0
		          |(nodeBaumBack[l][ (xo-1)%borderLenght, (yo)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildLowRightBack)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo)%borderLenght,(zo+1)%borderLenght].changed
		            &BMaskChildLowLeftFront)!=0
		          |(nodeBaumBack[l][ (xo)%borderLenght, (yo-1)%borderLenght,(zo)%borderLenght].changed
		            &BMaskChildUpLeftBack)!=0);     
		          
		}

		private void Serialisation()
		{ 
			
			FileStream s = new FileStream("Frame" + runCounter + ".ser",FileMode.Create);
			IFormatter f = new BinaryFormatter();
			f.Serialize(s, lstate);
			s.Close();			
		}
		public byte RightNeibState
		{
			get{return neigFieldBack[2, 1, 1];}
		}

		public byte LeftNeibState
		{
			get{return neigFieldBack[0, 1, 1];}
		}

		public byte BottonNeibState
		{
			get
			{
				return neigFieldBack[1, 0, 1];
			}
		}

		public byte TopNeibState
		{
			get
			{
				return neigFieldBack[1, 2, 1];
			}
		}

		public byte FrontNeibState
		{
			get
			{
				return neigFieldBack[1, 1, 0];
			}
		}

		public byte BackNeibState
		{
			get
			{
				return neigFieldBack[1, 1, 2];
			}
		}

		public byte BordBottonFrontNeibState
		{
			get
			{
				return neigFieldBack[1, 0, 0];
			}
		}

		public byte BordBottonBackNeibState
		{
			get
			{
				return neigFieldBack[1, 0, 2];
			}
		}

		public byte BordTopFrontNeibState
		{
			get
			{
				return neigFieldBack[1, 2, 0];
			}
		}

		public byte BordTopBackNeibState
		{
			get
			{
				return neigFieldBack[1, 2, 2];
			}
		}

		public byte BordLeftFrontNeibState
		{
			get
			{
				return neigFieldBack[0, 1, 0];
			}
		}

		public byte BordLeftBackeNeibState
		{
			get
			{
				return neigFieldBack[0, 1, 2];
			}
		}

		public byte BordRightFrontNeibState
		{
			get
			{
				return neigFieldBack[2, 1, 0];
			}
		}

		public byte BordRightBackNeibState
		{
			get
			{
				return neigFieldBack[2, 1, 2];
			}
		}

		public byte BordLeftBottonNeibState
		{
			get
			{
				return neigFieldBack[0, 0, 1];
			}
		}

		public byte BordLeftTopNeibState
		{
			get
			{
				return neigFieldBack[0, 2, 1];
			}
		}

		public byte BordRightBottonNeibState
		{
			get
			{
				return neigFieldBack[2, 0, 1];
			}
		}

		public byte BordRightTopNeibState
		{
			get
			{
				return neigFieldBack[2, 2, 1];
			}
		}

		public byte CornLeftBottonFrontNeibState
		{
			get
			{
				return neigFieldBack[0, 0, 0];
			}
		}

		public byte CornLeftBottonBackNeibState
		{
			get
			{
				return neigFieldBack[0, 0, 2];
			}
		}

		public byte CornLeftTopFrontNeibState
		{
			get
			{
				return neigFieldBack[0, 2, 0];
			}
		}

		public byte CornLeftTopBackNeibState
		{
			get
			{
				return neigFieldBack[0, 2, 2];
			}
		}

		public byte CornRightBottonBackNeibState
		{
			get
			{
				return neigFieldBack[2, 0, 2];
			}
		}

		public byte CornRightBottonFrontNeibState
		{
			get
			{
				return neigFieldBack[2, 0, 0];
			}
		}

		public byte CornRightTopBackNeibState
		{
			get
			{
				return neigFieldBack[2, 2, 2];
			}
		}

		public byte CornRightTopFrontNeibState
		{
			get
			{
				return neigFieldBack[2, 2, 0];
			}
		}
		abstract protected byte Rules (byte currentstate);
		abstract protected byte[] GiveUsedNeibDirection();
	}
}
